/* src/main.h - Dclarations principales
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Dfini juste si on peut utiliser des attributs (comme pour dire qu'une var ne sert pas et que
   donc un warning est superflut :p */
#ifdef __GNUC__

#if (__GNUC__ < 2) || (__GNUC__ == 2 && __GNUC_MINOR__ < 7)
#define NO_ATTRIBUTE
#endif

#else /* !__GNUC__ */

/* No attributes if we don't have gcc-2.7 or higher */
#define NO_ATTRIBUTE

#endif /* !__GNUC__ */

//#define DEBUG /* Definir pour debuger */
#define SPVERSION "1.0.0.0"
#define CTCP_DELIM_CHAR '\001'
#define MAXPARA 16
#define MAXLEN 524
//#define MAXBUF 102400

#define NICKLEN 30 + 2
#define CHNICKRAND "Inter"
#define TOPICLEN 248 + 2
#define HOSTLEN 63 + 1
#define REALEN 50 + 1
#define USERLEN 20 + 1
#define FICHIER_CONF "ucoderz.conf"
//ous ne voulez pas tout logger, mettez rien entre les "" des diffrents fichiers
#define LOG_CMDS "logs/cmds.log" // cmds sur le bot
#define LOG_PARSES "logs/parses.log" // msgs reu du serveur
#define LOG_FAUTH "logs/failed_auth.log" // identification sur username admin chou
#define LOG_ERREURS "logs/erreurs.log" // erreurs
#define WAIT_DEL_PARSES 172800 // Temps au bout duquel SCoderZ attend avant de del LOG_PARSES (172800 = 2 jours)
#define WAIT_DEL_LOGS 864000 // Temps au bout duquel SCoderZ attend avant de del les autres fichiers de logs (864000 = 10 jours)
#define USERS_FILE "database/usr.db"
#define BADCHANS_FILE "database/badchans.db"
#define CMDS_FILE "database/cmds.db"
#define HAVE_CRYPTHOST
#define HAVE_TRACK
#define HAVE_AUTOKILL // Si un user prend le pseudo d'un admin, si setkill -> kill/svsnick
#define NUMNICKBASE 64
#define PING_FREQ 90 /* interval des pings */
#define ALARMINTERVAL 25 /* interval de l'alarme */
#define CHANGE_NICK /* active/desactive l'auto changement de pseudo au lieu du kill */
#define WAIT_CONNECT 10 /* Temps qu'attend le serveur avant de retenter une connexion */
#ifdef NO_ATTRIBUTE
#define CVSINFO(id) static char unused_CVSinfo[] = id
#else /* NO_ATTRIBUTE */
#define CVSINFO(id) static char CVSinfo[] __attribute__ ((unused)) = id
#endif /* NO_ATTRIBUTE */
#define IsAnAdmin(x) ((x)) /* x est un admin ? */
#define IsAuthed(x) ((x)->user) /* x est identifi (real) ? (o x est aNick) */
//#define UserName(x) ((x)->user ? (x)->user->nick : (x)->nick)
//#define IsAway(x) (IsAuthed(x) && !(x)->user->authed) /* x est away ? (o x est anUser) */
//#define IsHere(x) (IsAuthed(x) && (x)->user->authed) /* x est identifi et prsent ? */

#define NOSUCHUSER "\002%s\002 n'est pas un Username enregistr."
#define DEFRAISON "Requested"
#define NOTCONNECTED "%s n'est pas connect."

typedef struct userinfo anUser;
typedef struct nickinfo aNick;
typedef struct killinfo aKill;
typedef struct joininfo aJoin;
#include <structs.h>
#include <proto.h>

#ifdef GLOBALS_DEF
struct robot bot;
struct bots uw;
struct userinfo *userhead = NULL;
/* Les needarg sonts les nombre d'arg minimum requis */

/* Dfinition des niveaux
 * 0 - keud
 * 1 - petit admin
 * 2 - moyen admin
 * 3 - grand admin
 * 4 - root
 * La theorie est donc que si un user possde une struct user dans sa struct nickinfo
 * (nick->user), c un admin sur l'uw
 */

struct uw_commands uw_cmds[] = {
 /* cmd,            function,             niveau, needarg, disable, secure, 0 */
 // Commandes admin
 {  "die",          die,                  4,      0, 0, 0, 0 },
 {  "restart",      restart_bot,          4,      0, 0, 0, 0 },
 {  "rehash",       rehash_conf,          4,      0, 0, 0, 0 },
 {  "addadmin",     do_admin,             4,      2, 0, 0, 0 },
 {  "deladmin",     del_admin,            4,      1, 0, 0, 0 },
 {  "adminlvl",     admin_level,          4,      2, 0, 0, 0 },
 {  "chcomname",    chcomname,            4,      2, 0, 0, 0 },
 {  "chlevel",      chlevel,              4,      2, 0, 0, 0 },
 {  "disable",      disable_cmd,          4,      2, 0, 0, 0 },
 {  "addbadchan",   add_badchan,          3,      2, 0, 0, 0 },
 {  "delbadchan",   del_badchan,          3,      1, 0, 0, 0 },
 {  "inviteme",     inviteme,             2,      0, 0, 0, 0 },
 {  "say",          admin_say,            2,      2, 1, 0, 0 },
 {  "cswall",       uw_wall,              2,      1, 0, 0, 0 },
 {  "reop",         reop,                 2,      0, 0, 0, 0 },
#ifdef HAVE_TRACK
 {  "track",         cmd_track,                 3,      1, 0, 0, 0 },
#endif
 {  "match",        admin_match,          2,      0, 0, 0, 0 },
 {  "user",         admin_user,           2,      2, 0, 0, 0 },
 {  "whoison",      whoison,              2,      1, 0, 0, 0 },
 {  "kill",         kill_user,            2,      1, 0, 0, 0 },
 {  "kickbanall",   kickbanall,           1,      0, 0, 0, 0 },
 {  "kickall",      kickall,              1,      0, 0, 0, 0 },
 {  "opall",        opall,                1,      1, 0, 0, 0 },
 {  "deopall",      deopall,              1,      1, 0, 0, 0 },
 {  "voiceall",     voiceall,             1,      1, 0, 0, 0 },
 {  "devoiceall",   devoiceall,           1,      1, 0, 0, 0 },
 {  "op",           op,                   1,      1, 0, 0, 0 },
 {  "deop",         deop,                 1,      1, 0, 0, 0 },
 {  "do",           admin_do,             1,      2, 0, 0, 0 },
 {  "devoice",      devoice,              1,      1, 0, 0, 0 },
 {  "voice",        voice,                1,      1, 0, 0, 0 },
 {  "drop",         drop_user,            1,      1, 0, 1, 0 },
 // Paramtres
 {  "setkill",      set_kill,             1,      0, 0, 0, 0 },
 {  "whois",        uw_whois,             1,      0, 0, 0, 0 },
 {  "listbadchans", list_badchans,        1,      0, 0, 0, 0 },
 {  "verify",       verify,               1,      1, 0, 0, 0 },
 {  "newpass",      ns_newpass,           1,      1, 0, 1, 0 },
 // Commandes users
 {  "hello",        hello_world,          0,      3, 0, 1, 0 },
 {  "login",        ns_login,             0,      2, 0, 1, 0 },
 {  "lastseen",     lastseen,             0,      1, 0, 0, 0 },
 {  "aide",         aide,                 0,      0, 0, 0, 0 },
 {  "showcommands", showcommands,         0,      0, 0, 0, 0 },
 {  "uptime",       uptime,               0,      0, 0, 0, 0 },
 {  "copyright",    copyright,            0,      0, 0, 0, 0 },
 {  "map",          show_map,             0,      0, 0, 0, 0 },
 {  "admin",        show_admins,          0,      0, 0, 0, 0 },
 {  "ignorelist",   show_ignores,         0,      0, 0, 0, 0 },
 {  "oubli",        oubli_pass,           0,      2, 0, 0, 0 },
 {  "\001ping",     ctcp_ping,            0,      0, 0, 0, 0 },
 {  "\001version\001", ctcp_version,      0,      0, 0, 0, 0 },
 {  "",             NULL,                 0,      0, 0, 0, 0 }
};
struct aServ servtab[64];
struct nickinfo *nickhead = NULL;
struct burstinfo *bursthead = NULL;
struct mapinfo *maphead = NULL;
struct badchans *badchead = NULL;
struct killinfo *killhead = NULL;
struct ignore *ignorehead = NULL;
#ifdef HAVE_TRACK
struct track *trackhead = NULL;
#endif

char base64[64] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789[]";
char quit_msg[100];
char pasdeperm[200];
char tbuff[70];
char parvbuff[500];
char ndbuff[230];
char network[100];
char mailprog[100];
int STS;
int kill_interval = 25;
int want_to_quit = 0;
int burst;
int tuptime = 0;
int premiere = 0;
int tidle;
int end_map = 0;
int registered;
int clonenb = 5;
int clonetmp = 3600;
int clonewar = 3;
int dataQ = 0;
int dataS = 0;
int changenick=0;
int maxlastseen=1000000;
int killforflood=0;
int ignoretime=600;
int adminexempt=1;
int lastresetparse=0;
int lastresetlogs=0;
#else
extern struct robot bot;
extern struct bots uw;
extern struct aServ servtab[];
extern struct uw_commands uw_cmds[];
// Prcision, welcome service
extern struct nickinfo *nickhead;
extern struct userinfo *userhead;
extern struct burstinfo *bursthead;
extern struct mapinfo *maphead;
extern struct badchans *badchead;
extern struct killinfo *killhead;
extern struct ignore *ignorehead;
#ifdef HAVE_TRACK
extern struct track *trackhead;
#endif

extern char base64[];
extern char quit_msg[];
extern int STS;
extern int kill_interval;
extern int tuptime;
extern int tidle;
extern int premiere;
extern int end_map;
extern char pasdeperm[];
extern char tbuff[];
extern char parvbuff[];
extern char ndbuff[];
extern char network[];
extern char mailprog[];
extern int want_to_quit;
extern int burst;
extern int dataQ;
extern int dataS;
extern int changenick;
extern int registered;
extern int clonenb;
extern int clonetmp;
extern int clonewar;
extern int maxlastseen;
extern int ignoretime;
extern int killforflood;
extern int adminexempt;
extern int lastresetparse;
extern int lastresetlogs;
#endif
