/* include/proto.h - Dclaration des diffrentes fonctions
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// Fonctions principales
int init_bot(int, int);
void sig_reload (int);
void sig_handler (int crap);
void sig_alarm(int);
void run_bot(int sock);

// Parses
void parse_this(int, char *);
void m_ping(int, int, char **);
void m_privmsg(int, int, char **);
void m_pass(int, int, char **);
void m_kick(int, int, char **);
void m_part(int, int, char **);
void m_join(int, int, char **);
void m_version(int, int, char **);
void m_mode(int, int, char **);
void m_eob(int, int, char **);
void m_squit(int, int, char **);
void m_server(int, int, char **);
void m_create(int, int, char **);
void m_nick(int, int, char **);
void m_005(int, int, char **);
void m_007(int, int, char **);
void m_quit(int, int, char **);
void m_burst(int, int, char **);
void m_away(int, int, char **);
void m_sethost(int, int, char **);
void m_setident(int, int, char **);
void m_whois(int, int, char **);
void m_kill(int, int, char **);
void m_topic(int, int, char **);

// Outils serveur
void putserv(const char *, ...);
void putchan(const char *, ...);
int resolve(char *host);
void putlog(char *, const char *, ...);
char *num2serv(char);
char *nick2num(char *);
char *make_servnum(int);
void uwntc(char *, const char *, ...);
void log(char *, char *, ...);
int findserv (char *name);
int decode_num (char *);
char *num2nick(char *);
int countdots(char *);
//char *convert_addr(char *, char *);
int is_ip(char *);
void translate_esc(char *, char *, char *);
void uwmap();
void uwmode(const char *, const char *, ...);
void uwtopic(const char *, const char *, ...);
void uwkick(const char *, const char *, const char *, ...);
void uwpart(const char *, const char *, ...);
void uwwallops(const char *, ...);

// Autres outils
void strupr(char *);
char *bottime();
void strip_newline(char *);
char *mkpass(char *, char *);
char *duration(int);
char *conv_char(char *chan);
void strlwr(char *buf);
int is_num(char *num);
char *get_time(long ttime);
char *parv2msg(int parc, char **parv, int base);
int IsRegNick(char *);
void syntax_cmd(char *, char *, char *);
int chan_check(char *, char *);
//int IsBadChan(char *);
int IsBadNick(char *);
int IsRegChan(char *);
int match(const char *, const char *);
char *IsAnOwner(char *);
char *IsOwner(char *, char *);
void do_killcheck();
int check_protect(aNick *, aNick *, char *);
long convert_duration(char *, long);
int ChanLevel(char *nick, char *chan);
void check_kills();
void check_bans();
void check_ignores();
void check_accounts();
//void uwwall(const char *, ...);
#ifdef HAVE_CRYPTHOST
char *hostprot(unsigned char *, unsigned char *);
#endif
char *strip_lastword(char *rest);
int getgloballevel(aNick *nick);
int isignore(aNick *nick);
#ifdef HAVE_TRACK
struct track *istrack(char *user);
void del_track(char *nick);
#endif
//char *UserNick(aNick *nick);

// Fichiers
int load_config(char *);
void load_users();
void write_anuser(char *);
void write_userlist();
void write_users();
void write_badchans();
void load_badchans();
void write_achan(char *);
void write_chans();
void write_chanlist();
void load_chans();
void write_welcome();
void load_welcome();
void write_badnicks();
void load_badnicks();
void write_cmds();
void load_cmds();

// Get Infos
struct userinfo *getuserinfo(char *);
struct nickinfo *getnickinfo(char *);
struct badchans *getbadchan(char *);
struct chaninfo *getchaninfo(char *);
struct badnicks *getbadnick(char *);
struct joininfo *getjoininfo(char *, char *);
//struct access *getaccesinfo(char *, char *);
struct nickinfo *getnickbynick(char *);

// Add/Del infos
void add_memo(char *, char *,int, char *);
void del_memo(char *, int);
void add_regnick(char *, char *, int, int, int, int, char *);
void del_regnick(char *);
void del_nickinfo(char *);
#ifdef HAVE_CRYPTHOST
void add_nickinfo(char *, char *, char *, char *, char *, char *, char *, char *, long, char *);
#else
void add_nickinfo(char *, char *, char *, char *, char *, char *, char *, long, char *);
#endif
void free_maplist();
void free_burst();
void add_mapinfo(char *);
void add_burst(char *, char *, long );
void add_abadchan(char *, char *);
void del_abadchan(char *);
void add_killinfo(char *, char *, long, int);
void del_killinfo(char *, char *);
void add_join(char *, char *, int, int, long, int);
void del_join(char *, char *);
void add_ignore(char *, long);
void del_ignore(char *);

// Commandes :
void register_user(aNick *nick, int parc, char **parv);
int checkflood(aNick *nick);
char *getbanmask(char *nick, char *ident, char *host, int bantype);
void hello_world(aNick *nick, int parc, char **parv);
void drop_user(aNick *nick, int parc, char **parv);
void showcommands(aNick *nick, int parc, char **parv);
void uptime(aNick *nick, int parc, char **parv);
void ns_login(aNick *nick, int parc, char **parv);
void ctcp_ping(aNick *nick, int parc, char **parv);
void ctcp_version(aNick *nick, int parc, char **parv);
void copyright(aNick *nick, int parc, char **parv);
void die(aNick *nick, int parc, char **parv);
//void nicklist(aNick *nick, int parc, char **parv);
void inviteme(aNick *nick, int parc, char **parv);
void show_admins(aNick *nick, int parc, char **parv);
void show_map(aNick *nick, int parc, char **parv);
void aide(aNick *nick, int parc, char **parv);
void ns_newpass(aNick *nick, int parc, char **parv);
void add_badchan(aNick *nick, int parc, char **parv);
void del_badchan(aNick *nick, int parc, char **parv);
void list_badchans(aNick *nick, int parc, char **parv);
void do_admin(aNick *nick, int parc, char **parv);
void del_admin(aNick *nick, int parc, char **parv);
void admin_level(aNick *nick, int parc, char **parv);
void uw_whois(aNick *nick, int parc, char **parv);
void op(aNick *nick, int parc, char **parv);
void deop(aNick *nick, int parc, char **parv);
void kick(aNick *nick, int parc, char **parv);
void kickban(aNick *nick, int parc, char **parv);
char *getchanuser(char *chan);
void whoison(aNick *nick, int parc, char **parv);
void opall(aNick *nick, int parc, char **parv);
void deopall(aNick *nick, int parc, char **parv);
void mode(aNick *nick, int parc, char **parv);
void topic(aNick *nick, int parc, char **parv);
void voice(aNick *nick, int parc, char **parv);
void devoice(aNick *nick, int parc, char **parv);
void admin_do(aNick *nick, int parc, char **parv);
void admin_say(aNick *nick, int parc, char **parv);
void lastseen(aNick *nick, int parc, char **parv);
void voiceall(aNick *nick, int parc, char **parv);
void devoiceall(aNick *nick, int parc, char **parv);
void kickbanall(aNick *nick, int parc, char **parv);
void kickall(aNick *nick, int parc, char **parv);
void rehash_conf(aNick *nick, int parc, char **parv);
void restart_bot(aNick *nick, int parc, char **parv);
void show_ignores(aNick *nick, int parc, char **parv);
void reop(aNick *nick, int parc, char **parv);
void chcomname(aNick *nick, int parc, char **parv);
void chlevel(aNick *nick, int parc, char **parv);
void oubli_pass(aNick *nick, int parc, char **parv);
void disable_cmd(aNick *nick, int parc, char **parv);
void cmd_track(aNick *nick, int parc, char **parv);
void admin_user(aNick *nick, int parc, char **parv);
void uw_wall(aNick *nick, int parc, char **parv);
void admin_match(aNick *nick, int parc, char **parv);
void verify(aNick *nick, int parc, char **parv);
void set_kill(aNick *nick, int parc, char **parv);
void add_badchan(aNick *nick, int parc, char **parv);
void del_badchan(aNick *nick, int parc, char **parv);
void list_badchan(aNick *nick, int parc, char **parv);
void kill_user(aNick *nick, int parc, char **parv);
