/* include/structs.h - Dclaration des diffrentes structures
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//------------------- Structures robot -------------------
struct robot {
  char server[256];
  char servnum[16];
  int num;
  char pass[256];
  int port;
  char name[256];
  char ip[30];
  char chan[201];
  char cara;
  int sock;
  int ipnum;
};

struct bots {
  char nick[NICKLEN];
  char ident[USERLEN];
  char host[HOSTLEN];
  char name[REALEN];
  char chan[201];
  char mode[10];
  char num[8];
  int actif;
};

//------------------- Structures conf, parses et cmds -------------------
struct aConfPara {
  char *name;
  int flag;
};

struct aMsg {
  char *cmd;
  void (*func) (int sock, int parc, char **parv);
};

struct uw_commands {
   char cmd[15];
   void (*func) (aNick *nick, int parc, char **parv);
   int level;
   int args;
   int disable;
   int secure;
   int used;
   char realcmd[15];
};

//------------------- Structures informations serveurs -------------------
struct aServ {
  int stat;
#define ST_NOSERV 0
#define ST_BURST 1
#define ST_ONLINE 2
  int hopcount;
  char chars;
  char name[256];
};

struct mapinfo
{
  char mapline[100];
  struct mapinfo *next;
};

struct burstinfo
{
   char channel[201];
   char modes[100];
   long chanstamp;
   struct burstinfo *next;
};

//------------------- Structures users et accs -------------------
struct nickinfo {
   char nick[NICKLEN];
   char ident[USERLEN];
   char host[HOSTLEN];
#ifdef HAVE_CRYPTHOST
   char crypt[HOSTLEN];
#endif
   char server[100];
   char name[REALEN];
   char base64[6];
   char numeric[8];
   int is_oper;
   char modes[10];
   int away;
   long ttmco;
   long floodtime;
   int floodcount;
   struct userinfo *user;
   struct nickinfo *next;
   struct joininfo *joinhead;
};

struct userinfo {
   char nick[NICKLEN];
   char passwd[20];
   int level;
   int lastseend;
   int authed;
   int suspendu;
   int setkill;
   char mail[150];
   int want_to_drop;
   struct access *accesshead;
   struct memos *memohead;
   struct userinfo *next;
};

struct joininfo
{
   char channel[201];
   int is_op;
   int is_voice;
   char modes[100];
   long timestmp;
   struct joininfo *next;
};

//------------------- Structures chans -------------------
struct badchans {
	char chaine[100];
	char raison[150];
	struct badchans *next;
};

//------------------- Structures flood et kill -------------------
struct killinfo
{
   char nick[NICKLEN];
   char numeric[8];
   long timestamp;
   int why;
   struct killinfo *next;
};

struct ignore
{
	char host[HOSTLEN];
	long exp;
	struct ignore *next;
};

struct track
{
	char nick[NICKLEN];
	char reqn[NICKLEN];
	char requ[5];
	long from;
	long expire;
	struct track *next;
};
