/* src/add_info.c - Ajout d'informations en mmoire
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <time.h>
#include "main.h"

CVSINFO("$Id: add_info.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

#ifdef HAVE_CRYPTHOST
void add_nickinfo(char *nick, char *user, char *host, char *crypt, char *base64, char *num, char *server, char *name, long ttmco, char *modes)
#else
void add_nickinfo(char *nick, char *user, char *host, char *base64, char *num, char *server, char *name, long ttmco, char *modes)
#endif
{
   struct nickinfo *new, *current;
   new = (struct nickinfo *) calloc(1, sizeof(struct nickinfo));
   if(new != NULL)
   {
      new->next = NULL;
      strncpy(new->nick, nick, NICKLEN);
      strncpy(new->ident, user, USERLEN);
      strncpy(new->host, host, HOSTLEN);
#ifdef HAVE_CRYPTHOST
      strncpy(new->crypt, strchr(modes, 'k') ? host : crypt, HOSTLEN);
#endif
      strcpy(new->base64, base64);
      strcpy(new->numeric, num);
      strcpy(new->server, server);
      strncpy(new->name, name, REALEN);
      strcpy(new->modes, modes);
      new->is_oper = strchr(modes, 'o') ? 1 : 0;
      new->ttmco=ttmco;
	  new->floodtime=time(NULL);
	  new->floodcount=0;
      if(nickhead == NULL) nickhead = new;
      else
      {
         current = nickhead;
         while(current->next != NULL)
         {
	    if(!strcasecmp(new->nick, current->nick)) return;
            current = current->next;
         }
         current->next = new;
      }
   }
}

void add_mapinfo(char *line)
{
   struct mapinfo *new, *current;
   new = (struct mapinfo *) calloc(1, sizeof(struct mapinfo));
   if(new)
   {
      new->next = NULL;
      strncpy(new->mapline, line, 100);
      if(!maphead) maphead = new;
      else
      {
         current = maphead;
         while(current->next) current = current->next;
         current->next = new;
      }
   }
}

void add_burst(char *channel, char *modes, long chanstamp)
{
   struct burstinfo *new, *current;
   new = (struct burstinfo *) calloc(1, sizeof(struct burstinfo));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->channel, channel);
      strcpy(new->modes, modes);
      new->chanstamp = chanstamp;
      if(bursthead == NULL) bursthead = new;
      else
      {
         current = bursthead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
}

void add_abadchan(char *chaine, char *raison)
{
   struct badchans *new, *current;
   new = (struct badchans *) calloc(1, sizeof(struct badchans));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->chaine, chaine);
      strcpy(new->raison, raison);
      if(badchead == NULL) badchead = new;
      else
      {
         current = badchead;
         while(current->next != NULL)
         {
	    if(!match(current->chaine, new->chaine)) return;
            current = current->next;
         }
         current->next = new;
      }
   }
}

void add_killinfo(char *nick, char *numeric, long timestamp, int why)
{
   struct killinfo *new, *current;
   new = (struct killinfo *) calloc(1, sizeof(struct killinfo));

   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->nick, nick);
      strcpy(new->numeric, numeric);
      new->timestamp = timestamp;
      new->why = why;
      if(killhead == NULL) killhead = new;
      else
      {
         current = killhead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
}

void add_regnick(char *user, char *pass, int lastseend, int level, int setkill, int suspendu, char *mail)
{
	struct userinfo *new, *current;
	new = (struct userinfo *) calloc(1,sizeof(struct userinfo));
	if(new != NULL)
	{
		new->next = NULL;
		strcpy(new->nick, user);
		strcpy(new->passwd, pass);
		new->lastseend = lastseend;
		new->level = level;
		new->setkill = setkill;
		new->suspendu = suspendu;
		strcpy(new->mail, mail);
		new->want_to_drop = 0;
		if(userhead == NULL) userhead = new;
		else
		{
			current = userhead;
			while(current->next != NULL)
			{
				if(!strcasecmp(new->nick, current->nick)) return;
				current = current->next;
			}
			current->next = new;
		}
	}
}

void add_join(char *nick, char *chan, int is_op, int is_voice, long timestamp, int is_burst)
{
	aNick *nnick;
	aJoin *new, *join;
	struct badchans *bd = NULL;
	char *parv[100];

	if(userhead == NULL) return;

	//On ajoute la struct sur le bon nick
	nnick = nickhead;
	while(nnick != NULL)
	{
		if(!strcasecmp(nick, nnick->nick))
		{
			new = (struct joininfo *) calloc(1, sizeof(struct joininfo));
			if(new != NULL)
			{
				new->next = NULL;
				strcpy(new->channel, chan);
				new->is_op = is_op;
				new->is_voice = is_voice;
				new->timestmp = timestamp;
				if(nnick->joinhead == NULL) nnick->joinhead = new;
				else
				{
					join = nnick->joinhead;
					while(join->next != NULL)
					{
						if(!strcasecmp(new->channel, join->channel)) return;
						join = join->next;
					}
					join->next = new;
				}
			}
			break;
		}
		nnick = nnick->next;
	}

	for(bd=badchead;bd;bd=bd->next)
		if(!match(bd->chaine, chan))
		{
			putserv(":%s JOIN %s\n", uw.nick, chan);
			putlog("\2JOIN\2 %s par %s", chan, uw.nick);
			uwmode(chan, "+osmint %s\n", uw.num);
			uwtopic(chan, "Salon illgal: %s\n", bd->raison);
			parv[0] = uw.nick;
			parv[1] = chan;
			parv[2] = bd->raison;
			parv[3] = NULL;
			kickall(NULL, 2, parv);
		}


	return;

}

void add_ignore(char *host, long expiration)
{
   struct ignore *new, *current;
   new = (struct ignore *) calloc(1, sizeof(struct ignore));
   if(new)
   {
      new->next = NULL;
      strncpy(new->host, host, HOSTLEN);
      new->exp = expiration;
      if(!ignorehead) ignorehead = new;
      else
      {
         current = ignorehead;
         while(current->next) current = current->next;
         current->next = new;
      }
   }
}
