/* src/aide.c - Aide
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <ctype.h>
#include <main.h>

CVSINFO("$Id: aide.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

/* Note: Les fonctions suivantes ont t reprises du CS6.2  IRCore.
 *       Elles ont t adapts pour ces services.
 */

void syntax_cmd(char *botnick, char *nwho, char *cmd)
{
   FILE *fp;
   char buffer[500], tbuf[500], cmdhelp[70], ptr[50];

   buffer[0] = '\0';
   tbuf[0]='\0';
   cmdhelp[0]='\0';
   ptr[0] = '\0';

   if(!cmd)
   {
      sprintf(cmdhelp, "syntax/SHOWCOMMANDS");
      if(!(fp = fopen(cmdhelp, "r"))) return;
      while(fgets(buffer, 100, fp) != NULL)
      {
         translate_esc(buffer, tbuf, botnick);
		 uwntc(nwho, "%s", tbuf);
      }
      fclose(fp);
      return;
   }
   strncpy(ptr, cmd, 50);
   strupr(ptr);
   snprintf(cmdhelp, 70, "syntax/%s", ptr);
   if(!(fp = fopen(cmdhelp, "r")))
   {
	  uwntc(nwho, "\002Commande inconnue (ou aucune aide).");
      return;
   }
   while(fgets(buffer, 400, fp))
   {
      translate_esc(buffer, tbuf, botnick);
	  uwntc(nwho, "%s", tbuf);
   }
   uwntc(nwho, "Tapez \002/msg %s AIDE %s\002 pour plus d'informations.", uw.nick, ptr);
   fclose(fp);
}

void aide(aNick *nick, int parc, char **parv)
{
   FILE *fp;
   char buffer[402], tbuf[500], cmdhelp[100], ptr[50], *ptr1 = NULL;
   int i;

   buffer[0] = '\0';
   tbuf[0]='\0';
   cmdhelp[0]='\0';
   ptr[0] = '\0';

   if(parc < 1)
   {
      sprintf(cmdhelp, "aide/SHOWCOMMANDS");
      if((fp = fopen(cmdhelp, "r")) == NULL) return;
      while(fgets(buffer, 400, fp) != NULL)
      {
         translate_esc(buffer, tbuf, parv[0]);
         uwntc(nick->numeric, "%s", tbuf);
      }
      fclose(fp);
      return;
   }
   strncpy(ptr, parv[1], 50);
   if(!isalpha(*parv[1]))
   {
      uwntc(nick->numeric, "\002Caractre invalide.");
      return;
   }
   if((ptr1 = strchr(ptr, ' '))) *ptr1++ = '\0';
   strupr(ptr);
   snprintf(cmdhelp, 100, "aide/%s", ptr);
   if((fp = fopen(cmdhelp, "r")) == NULL)
   {
      uwntc(nick->numeric, "\002Cette commande n'existe pas (ou aide non trouve).");
      return;
   }
   uwntc(nick->numeric, "   --[ \002\0032Aide sur\0033 %s\003\002 ]--", ptr);
   i=0;
   while(fgets(buffer, 400, fp) != NULL)
   {
     if(i==1)
        for (i=0; uw_cmds[i].cmd[0] != '\0'; i++)
          if (((char *)strcasecmp(uw_cmds[i].cmd,ptr))==NULL)
             uwntc(nick->numeric, "Niveau: \002\003%s\002\003 %d\n", (uw_cmds[i].level > 1) ? (uw_cmds[i].level <5) ? "4ADMIN" : "2CHAN" : "3USER" , uw_cmds[i].level);
     translate_esc(buffer, tbuf, parv[0]);
     uwntc(nick->numeric, "%s", tbuf);
     i++;
   }
   fclose(fp);
}

void translate_esc(char *buffer, char *tbuffer, char *botnick)
{
   int i = 0, j = 0, k = 0;
   while(buffer[i] != '\0')
   {
      if(buffer[i] == '\\')
      {
         switch(buffer[i+1])
         {
         case 'b':
            tbuffer[k] = '\037';
            break;
         case 'i':
            tbuffer[k] = '\026';
            break;
         case 'r':
            tbuffer[k] = ' ';
            break;
         case 'n':
            while(botnick[j] != '\0')
            {
               tbuffer[k] = botnick[j];
               k++;
               j++;
            }
            k--;
            break;
         case 'c':
            while(bot.chan[j] != '\0')
            {
               tbuffer[k] = bot.chan[j];
               k++;
               j++;
            }
            k--;
            break;
         }
         i+=2;
         k++;
         continue;
      }
      tbuffer[k] = buffer[i];
      i++;
      k++;
   }
   tbuffer[k] = '\0';
}
