#include 	<stdio.h>
#include        <netinet/in.h>
#include        <unistd.h>
#include        <netdb.h>
#include        <sys/types.h>
#include        <sys/socket.h>

#include "global.h"
#include "nn.h"
#include "rsaref.h"

#define SERV_PORT 2222

struct cryptdata {  
 unsigned char content[32]; 
 unsigned char encryptedContent[32];
 unsigned char encryptedSignature[MAX_PEM_ENCRYPTED_SIGNATURE_LEN];
 unsigned char encryptedKey[MAX_PEM_ENCRYPTED_KEY_LEN]; 
 unsigned char iv[8];
              
 unsigned int contentLen;
 unsigned int encryptedContentLen;
 unsigned int encryptedSignatureLen;
 unsigned int encryptedKeyLen;
 R_RSA_PUBLIC_KEY  pubk;
 R_RSA_PRIVATE_KEY privk;
};

static void PrintError (task, type)
char *task;
int type;
{
  char *typeString, buf[80];

  if (type == 0) {
    puts (task);
    return;
  }
  
  /* Convert the type to a string if it is recognized.
   */
  switch (type) {
  case RE_CONTENT_ENCODING:
    typeString = "(Encrypted) content has RFC 1113 encoding error";
    break;
  case RE_DIGEST_ALGORITHM:
    typeString = "Message-digest algorithm is invalid";
    break;
  case RE_KEY:
    typeString = "Recovered DES key cannot decrypt encrypted content or encrypt signature";
    break;
  case RE_KEY_ENCODING:
    typeString = "Encrypted key has RFC 1113 encoding error";
    break;
  case RE_MODULUS_LEN:
    typeString = "Modulus length is invalid";
    break;
  case RE_NEED_RANDOM:
    typeString = "Random structure is not seeded";
    break;
  case RE_PRIVATE_KEY:
    typeString = "Private key cannot encrypt message digest, or cannot decrypt encrypted key";
    break;
  case RE_PUBLIC_KEY:
    typeString = "Public key cannot encrypt DES key, or cannot decrypt signature";
    break;
  case RE_SIGNATURE:
    typeString = "Signature on content or block is incorrect";
    break;
  case RE_SIGNATURE_ENCODING:
    typeString = "(Encrypted) signature has RFC 1113 encoding error";
    break;
    
  default:
    sprintf (buf, "Code 0x%04x", type);
    typeString = buf;
  }

  printf ("ERROR: %s while %s\n", typeString, task);  
  fflush (stdout);
}

static void InitRandomStruct (randomStruct)
R_RANDOM_STRUCT *randomStruct;
{
  static unsigned char seedByte = 0;
  unsigned int bytesNeeded;
  
  R_RandomInit (randomStruct);
  
  /* Initialize with all zero seed bytes, which will not yield an actual
       random number output.
   */
  while (1) {
    R_GetRandomBytesNeeded (&bytesNeeded, randomStruct);
    if (bytesNeeded == 0)
      break;
    
    R_RandomUpdate (randomStruct, &seedByte, 1);
  }
}


main ()
{
  struct cryptdata c;
  struct cryptdata c2;
  struct sockaddr_in sin;
  int i;                 
  int r;
  int sock_c,sock;
  int sinlen = sizeof(sin); 
  char buf[255];
   
  R_RANDOM_STRUCT randomStruct;
  R_RSA_PROTO_KEY protoKey;
  R_RSA_PUBLIC_KEY clientk;
  
  memset(c.content,0,sizeof(c.content));
  
   InitRandomStruct (&randomStruct);
   protoKey.bits = (unsigned int)508;
   protoKey.useFermat4 = 1;
    
   r = R_GeneratePEMKeys (&c.pubk, &c.privk, 
                          &protoKey, 
                          &randomStruct
                          );    

  printf("Key generated\n");
  
  sock = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);

  if ( sock == -1 ) {
     perror ("socket");
     exit (-1);
    }

sin.sin_family	    = AF_INET;
sin.sin_addr.s_addr = htonl(INADDR_ANY);
sin.sin_port        = htons(SERV_PORT);

if ( (bind(sock,(struct sockaddr *)&sin,sizeof(sin))) == -1 ) {
   perror ("bind");
   exit  (-1);
  }

if ( listen ( sock , 10)  == -1 ) {
    perror ("listen");
    exit (-1);
   }

while ( 1 ) 

      if ( sock_c =accept(sock,(struct sockaddr *)&sin,&sinlen)) 

      if ( fork () == 0 ) 
    {
 
     
    printf("send our public key..\n"); 
    write ( sock_c, &c.pubk, sizeof(c.pubk));
    usleep (500000); 
      
   printf ("receive the client pub key..\n");
   read   (sock_c,&clientk,sizeof(clientk));
   usleep (500000);
   
   printf("now receive the client password encrypted..\n");
   
   read(sock_c, &c2, sizeof(c2)); 
    
   memset(buf, 0, sizeof(buf));
   i = sizeof(buf);

 r =  R_OpenPEMBlock (
                   buf, 
                   &i,
                   c2.encryptedContent,
                   c2.encryptedContentLen, 
                   c2.encryptedKey,
                   c2.encryptedKeyLen, 
                   c2.encryptedSignature, 
                   c2.encryptedSignatureLen, 
                   c2.iv,
                   DA_MD2, 
                   &c.privk, 
                   &clientk
                   );

 printf("mot recue:%s\n",buf);
 
 printf("ok let's send the channel key..\n");  
 
 strcpy(c.content,"OK!#");
 c.contentLen = 4;
 
 r =  R_SealPEMBlock (
                   c.encryptedContent, 
                   &c.encryptedContentLen, 
                   c.encryptedKey,
                   &c.encryptedKeyLen, 
                   c.encryptedSignature, 
                   &c.encryptedSignatureLen, 
                   c.iv,
                   c.content, 
                   c.contentLen, 
                   DA_MD2, 
                   &clientk, 
                   &c.privk,
                   &randomStruct);
memset (c.privk, 0, sizeof(c.privk));
memset (c.content,0,c.contentLen);

write (sock_c,&c,sizeof(c));                  
 
 exit(0);
 }
}