/* src/del_info.c - Suppression d'informations en mmoire
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: del_info.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

void del_nickinfo(char *numeric)
{
   struct nickinfo *current, *previous = NULL, *tmp;
   struct joininfo *chan, *ct;

   current = nickhead;
   while(current != NULL)
   {
      if(!strcmp(numeric, current->numeric)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(!current) return;
   else
   {
      if(current == nickhead) nickhead = nickhead->next;
      else previous->next = current->next;
      if(current->user) current->user->authed = 0;
      tmp = current->next;

      for(chan=current->joinhead;chan;chan=ct)
      {
		  ct=chan->next;
		  free(chan);
	  }

      free(current);
      current = NULL;
   }
}

void free_maplist()
{
   struct mapinfo *map, *tmp;
   for(map=maphead;map;map=tmp)
   {
	   tmp=map->next;
	   free(map);
   }
   maphead=NULL;
}

void free_burst()
{
   struct burstinfo *burst, *tmp;
   for(burst=bursthead;burst;burst=tmp)
   {
	   tmp=burst->next;
	   free(burst);
   }
   bursthead=NULL;
}

void del_abadchan(char *chaine)
{
   struct badchans *current, *previous = NULL, *tmp;

   current = badchead;
   while(current != NULL)
   {
      if(!strcasecmp(chaine, current->chaine)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(current != NULL)
   {
      if(current == badchead) badchead = badchead->next;
      else previous->next = current->next;
      tmp = current->next;
      free(current);
      current = NULL;
   }
}

void del_killinfo(char *nick, char *numeric)
{
   struct killinfo *current, *previous = NULL, *tmp;

   current = killhead;
   while(current != NULL)
   {
      if(!strcmp(numeric, current->numeric) && !strcasecmp(nick, current->nick))
      {
		  if(current == killhead) killhead = killhead->next;
		  else previous->next = current->next;
		  tmp=current;
		  current = current->next;
		  free(tmp);
		  return;
      }
      else
      {
         previous = current;
         current = current->next;
      }
   }
}

void del_join(char *nick, char *chan)
{
	struct nickinfo *nnick;
	aJoin *tmp, *current, *previous = NULL;

	if(userhead == NULL) return;
	nnick = nickhead;
	while(nnick != NULL)
	{
		if(!strcasecmp(nick, nnick->nick))
		{
			current = nnick->joinhead;
			while(current != NULL)
			{
				if(!strcasecmp(chan, current->channel)) break;
				else
				{
					previous = current;
					current = current->next;
				}
			}
			if(current != NULL)
			{
				if(current == nnick->joinhead) nnick->joinhead = nnick->joinhead->next;
				else previous->next = current->next;
				tmp = current->next;
				free(current);
				current = NULL;
				return;
			}
			return;
		}
		nnick = nnick->next;
	}
}

void del_regnick(char *user)
{
   struct userinfo *current, *previous = NULL, *tmp;

   current = userhead;
   while(current)
   {
      if(!strcmp(user, current->nick)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(!current) return;
   else
   {
      if(current == userhead) userhead = userhead->next;
      else previous->next = current->next;
      tmp = current->next;

      free(current);
      current = NULL;
   }
}

void del_ignore(char *host)
{
   struct ignore *current, *previous = NULL, *tmp;

   current = ignorehead;
   while(current)
   {
      if(!strcmp(host, current->host)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(!current) return;
   else
   {
      if(current == ignorehead) ignorehead = ignorehead->next;
      else previous->next = current->next;
      tmp = current->next;
      free(current);
      current = NULL;
   }
}
