/* src/divers.c - Diverses commandes
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <time.h>
#include "main.h"

CVSINFO("$Id: divers.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

void uptime(aNick *nick, int parc, char **parv)
{
   uwntc(nick->numeric, "Je suis connect depuis %s", duration(time(NULL) - tuptime));
   return;
}

void ctcp_ping(aNick *nick, int parc, char **parv)
{
   if(parc) uwntc(nick->numeric, "%cPING %s", CTCP_DELIM_CHAR, parv[1]);
   return;
}

void ctcp_version(aNick *nick, int parc, char **parv)
{
    uwntc(nick->numeric, "%cVERSION UWorlD CoderZ %s  Inter System%c", CTCP_DELIM_CHAR, SPVERSION, CTCP_DELIM_CHAR);
    uwntc(nick->numeric, "%cVERSION   Progs <Progs@Inter-System.Net>%c", CTCP_DELIM_CHAR, CTCP_DELIM_CHAR);
    uwntc(nick->numeric, "%cVERSION   Keeo <airweb@wanadoo.fr>%c", CTCP_DELIM_CHAR, CTCP_DELIM_CHAR);
	return;
}

void copyright(aNick *nick, int parc, char **parv)
{
   uwntc(nick->numeric, "UWorlD CoderZ %s  Inter System", SPVERSION);
   return;
}

void show_admins(aNick *nick, int parc, char **parv)
{
	anUser *user;
	struct nickinfo *nnick;
	char *what;

	uwntc(nick->numeric, "  \002\037\0034Prsent\003\037   \037\0034Niveau\003\037    \037\0034Username\003\037       \037\0034Pseudo\003\037");
	user = userhead;
	while(user)
	{
		if(IsAnAdmin(user))
		{
			what = user->authed ? "\002\0033OUI\003\002" : "\002\0034NON\003\002";
			if(!(nnick = getnickinfo(user->nick))) uwntc(nick->numeric, "  %-3s       %5d     %-12s", what, user->level, user->nick, nnick->nick);
			else uwntc(nick->numeric, "  %-3s       %5d     %-12s   \0032%s", what, user->level, user->nick, nnick->nick);
		}
		user = user->next;
	}
	return;
}

void show_map(aNick *nick, int parc, char **parv)
{
	struct mapinfo *map;
	for(map = maphead;map;map=map->next) uwntc(nick->numeric, map->mapline);
	return;
}

void show_ignores(aNick *nick, int parc, char **parv)
{
	struct ignore *i;
	int c = 0;
	long p = time(NULL);
	uwntc(nick->numeric, "List des Ignors:");
	for(i=ignorehead;i;i=i->next)
	{
		if(i->exp <= time(NULL))
		{
			del_ignore(i->host);
			continue;
		}
		c++;
		uwntc(nick->numeric,"\002%d\002. \002%s\002 Expire dans %s",c, i->host, duration(i->exp - p));
	}
	if(!c) uwntc(nick->numeric,"> Aucun actuellement.");
	return;
}


void reop(aNick *nick, int parc, char **parv)
{
	uwmode(uw.chan, "+o %s", uw.nick);
	return;
}

void lastseen(aNick *nick, int parc, char **parv)
{
	anUser *u;
	if(!(u=getuserinfo(parv[1])))
	{
		uwntc(nick->numeric, NOSUCHUSER, parv[1]);
		return;
	}
	uwntc(nick->numeric, "Dernier Login de %s il y a %s (%s)", u->nick, duration(time(NULL) - u->lastseend), get_time(u->lastseend));
	return;
}

void verify(aNick *nick, int parc, char **parv)
{
	struct nickinfo *u;
	if(!strcasecmp(parv[1], uw.nick))
	{
		uwntc(nick->numeric, "Yeah, c'est bien moi :)");
		return;
	}
	if(!strcasecmp(nick->nick, parv[1])) u = nick;
	else u = getnickbynick(parv[1]);
	if(!u)
	{
		uwntc(nick->numeric, NOTCONNECTED, parv[1]);
		return;
	}
	if(!u->user)
	{
		uwntc(nick->numeric, "%s n'est pas actuellement logu.", u->nick);
		return;
	}
	if(nick->user->level > 1 || !strcasecmp(nick->nick, u->nick)) uwntc(nick->numeric, "%s!%s@%s est logu sous l'username %s %s %s", u->nick, u->ident, u->host, u->user->nick, (u->user->level > 1) ? "- Administrateur des Services" : "", u->is_oper ? "- IRCop" : "");
	else uwntc(nick->numeric, "%s est logu sous l'username %s %s %s", u->nick, u->user->nick, (u->user->level > 1) ? "- Administrateur des Services" : "", u->is_oper ? " - IRCop" : "");
	return;
}

