/* src/fichiers.c - Lecture/criture des donnes
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: fichiers.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

struct aConfPara conftab[] = {
 { "SERVER", 0},
 { "IP", 0},
 { "PORT", 0},
 { "PASS", 0},
 { "NUMERIC", 0},
 { "NICK", 0},
 { "IDENT", 0},
 { "HOST", 0},
 { "BOTNAME", 0},
 { "CHAN", 0},
 { "QUIT_MSG", 0},
 { "MODES", 0},
 { "NAME", 0},
 { "PASDEPERM", 0},
 { "KILLNICK", 0},
 { "CHANGE_NICK", 0},
 { "KILLFORFLOOD", 0},
 { "IGNORETIME", 0},
 { "NETWORK", 0},
 { "MAILPROG", 0},
 { "CLONES:NOMBRE", 0},
 { "CLONES:TEMPS", 0},
 { "CLONES:WARNING", 0},
 { NULL, 0}
};

int load_config(char *filename)
{
  char *ptr;
  FILE *cfg;
  char buf[512];
  char param[512];
  char value[512];
  int i=0,n,f,a;

//  empty_exlist();
//  empty_modlist();

  if (!( cfg = fopen(filename,"r")))
  {
    perror("Impossible d'ouvrir le fichier de configuration");
    return -1;
  }

  while (fgets(buf, 512, cfg))
  {
    i++;
    n=strlen(buf);
    if (buf[n-1] == '\n') buf[n-1] = '\0';
    n=strlen(buf);
    if (buf[n-1] == '\r') buf[n-1] = '\0'; /* Windoze-editor friendly ;p */

    ptr=strchr(buf,'*');
    if (ptr) *ptr = '\0';

    f=0;
    for (n=0; n<strlen(buf); n++)
    {
      if ((buf[n] != ' ') && (buf[n] != '\t'))
      {
        f=1;
        break;
      }
    }

    if (f==0) continue; /* blank line are ignored */
    if (sscanf(buf, "%s %s", param, value)!=2)
    {
      printf("Fichier de configuration: Erreur ligne %u\n", i);
      fclose(cfg);
      return -1;
    }
    sscanf(buf, "%s %n", param, &a);
    strncpy(value, &buf[a], 512);

    if (!strcmp(param,"SERVER"))
    {
		if(countdots(value) < 1) {
			printf("Le Serveur d'Uplink semble invalide. (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[0].flag = 1;
      strncpy(bot.server, value, 256);
      continue;
    }
    if (!strcmp(param,"IP"))
    {
		if(strlen(value) > 16 || !is_ip(value)) {
			printf("L'IP %s semble invalide. (ligne %d)\n", value, i);
			fclose(cfg);
			return -1;
		}
      conftab[1].flag = 1;
      strncpy(bot.ip, value, 30);
      continue;
    }
    if (!strcmp(param,"PORT"))
    {
		if(!is_num(value) || atoi(value) <= 0 || atoi(value) > 65535) {
			printf("Port de link invalide: (ligne %d)\n", i);
			fclose(cfg);
			return -1;
		}
      conftab[2].flag = 1;
      bot.port = atoi(value);
      continue;
    }
    if (!strcmp(param,"PASS"))
    {
      conftab[3].flag = 1;
      strncpy(bot.pass, value, 256);
      continue;
    }
    if (!strcmp(param,"NUMERIC"))
    {
		if(!is_num(value) || atoi(value) > 64)
		{
			printf("Numeric non valide %s (Devrait etre entre 0 et 64) (ligne %d)\n",value,i);
			fclose(cfg);
			return -1;
		}
      conftab[4].flag = 1;
      bot.num = atoi(value);
      continue;
    }
    if (!strcmp(param,"NICK"))
    {
		conftab[5].flag = 1;
		strncpy(uw.nick, value, NICKLEN);
		if(strlen(value) > (NICKLEN-1)) printf("Nick du uw trop long, tronqu en %s (ligne %d)\n", uw.nick, i);
		continue;
    }
    if (!strcmp(param,"IDENT"))
    {
      conftab[6].flag = 1;
      strncpy(uw.ident, value, USERLEN);
      if(strlen(value) > (USERLEN-1)) printf("Ident du uw trop longue, tronque en %s (ligne %d)\n", uw.ident, i);
      continue;
    }
    if (!strcmp(param,"HOST"))
    {
      conftab[7].flag = 1;
      strncpy(uw.host, value, HOSTLEN);
      if(strlen(value) > (HOSTLEN-1)) printf("Host du uw trop longue, tronque en %s (ligne %d)\n", uw.host, i);
      continue;
    }
    if (!strcmp(param,"BOTNAME"))
    {
      conftab[8].flag = 1;
      strncpy(uw.name, value, REALEN);
      if(strlen(value) > (REALEN-1)) printf("RealName du uw trop long, tronqu en %s (ligne %d)\n", uw.name, i);
      continue;
    }
    if (!strcmp(param,"CHAN"))
    {
		if(value[0] != '#')
		{
			printf("Format de salon invalide '%c' (ligne %d)\n",value[0],i);
			fclose(cfg);
			return -1;
		}
      conftab[9].flag = 1;
      strncpy(uw.chan,value,200);
      continue;
    }
    if (!strcmp(param,"QUIT_MSG"))
    {
      conftab[10].flag = 1;
      strncpy(quit_msg, value, 100);
      continue;
    }
    if (!strcmp(param,"MODES"))
    {
      conftab[11].flag = 1;
      strncpy(uw.mode, value, 10);
      continue;
    }
    if (!strcmp(param,"NAME"))
    {
      conftab[12].flag = 1;
      strncpy(bot.name, value, 256);
      continue;
    }
    if (!strcmp(param,"PASDEPERM"))
    {
      conftab[13].flag = 1;
      strncpy(pasdeperm, value, 200);
      if(strlen(value) > 200) printf("Message d'Accs refus trop long, tronqu en %s (ligne %d)\n",pasdeperm,i);
      continue;
    }
    if (!strcmp(param,"KILLNICK"))
    {
		if(!is_num(value))
		{
			printf("Le temps d'attente pour les KILLs doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[14].flag = 1;
      kill_interval = atoi(value);
      continue;
    }
    if (!strcmp(param,"CHANGE_NICK"))
    {
      conftab[15].flag = 1;
      changenick = atoi(value);
      continue;
    }
    if (!strcmp(param,"KILLFORFLOOD"))
    {
		if(!is_num(value))
		{
			printf("Le Kill pour flood doit tre  1 ou 0 (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[16].flag = 1;
      killforflood = atoi(value);
      continue;
    }
    if (!strcmp(param,"IGNORETIME"))
    {
		if(!is_num(value))
		{
			printf("Le temps d'ignore doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[17].flag = 1;
      ignoretime = atoi(value);
      continue;
    }
    if (!strcmp(param,"NETWORK"))
    {
    	if(strchr(value, ' '))
	{
		printf("Le nom du rseau doit tre compos d'un seul mot (ex: Inter-System.net) (ligne %d)\n", i);
		fclose(cfg);
		return -1;
	}
    	conftab[18].flag = 1;
    	strncpy(network, value, 256);
	continue;
    }
    if (!strcmp(param,"MAILPROG"))
    {
    	conftab[19].flag = 1;
    	strncpy(mailprog, value, 256);
	continue;
    }
    if (!strcmp(param,"CLONES:NOMBRE"))
    {
		if(!is_num(value))
		{
			printf("Le nombre de clones (gline) doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[20].flag = 1;
      clonenb = atoi(value);
      continue;
    }
    if (!strcmp(param,"CLONES:TEMPS"))
    {
		if(!is_num(value))
		{
			printf("Le temps du gline pour clones doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[21].flag = 1;
      clonetmp = atoi(value);
      continue;
    }
    if (!strcmp(param,"CLONES:WARNING"))
    {
		if(!is_num(value))
		{
			printf("Le nombre de clones (warning) doit tre un nombre (ligne %d)\n",i);
			fclose(cfg);
			return -1;
		}
      conftab[22].flag = 1;
      clonewar = atoi(value);
      continue;
    }
    printf("Fichier de configuration: Erreur  la ligne %u\n", i);
    fclose(cfg);
    return -1;
  }
  for (i=0; conftab[i].name != NULL; i++)
  {
    if (!conftab[i].flag)
    {
      printf("Paramtre de configuration introuvable: %s\n", conftab[i].name);
      fclose(cfg);
      return -1;
    }
  }
  fclose(cfg);
  return 0;
}

void load_users()
{
	FILE *fp, *fp1;
	char buff[100], buff1[700], *user = NULL, *nuser = NULL;
	char *nick = NULL, *pass = NULL, *lastseend = NULL, *level = NULL, *field = NULL;
	char *setkill = NULL, *mail = NULL, *suspendu = NULL;
	int adm=0;

	if(!(fp = fopen(USERS_FILE, "r")))
	{
		premiere = 1;
		return;
	}
	while(fgets(buff, 100, fp) != NULL)
	{
		strip_newline(buff);
		user = strtok(buff, " ");
		nuser = conv_char(user);
		strlwr(nuser);
		sprintf(buff1, "database/usr/%s", nuser);
		if(!(fp1 = fopen(buff1, "r"))) continue;
		buff1[0] = '\0';

		while(fgets(buff1, 700, fp1) != NULL)
		{
			strip_newline(buff1);
			if((field = strchr(buff1, ' '))) *field++ = '\0';
			if(!strcmp(buff1, "NICK") && field != NULL)
			{
				nick = strtok(field, " ");
				pass = strtok(NULL, " ");
				level = strtok(NULL, " ");
				setkill = strtok(NULL, " ");
				lastseend = strtok(NULL, " ");
				suspendu = strtok(NULL, " ");
				mail = strtok(NULL, " ");
				add_regnick(nick, pass, atoi(lastseend), atoi(level), atoi(setkill), atoi(suspendu), mail);
				if(is_num(level) && atoi(level) > 1) adm = 1;
			}
			field[0] = '\0';
		}
		fclose(fp1);
	}
	fclose(fp);
	if(!adm) printf("Aucun Admin localis dans la Base de Donnes!!\n");
}

void write_userlist()
{
   FILE *fp;
   anUser *user;

   if(!(fp = fopen(USERS_FILE, "w"))) return;

   user=userhead;
   while(user != NULL)
   {
      fprintf(fp, "%s\n", user->nick);
      user = user->next;
   }
   fclose(fp);
   return;
}

void write_anuser(char *nick)
{
   anUser *user;
   FILE *fp1;
   char *nuser = NULL, buff[100];

   buff[0] = '\0';

   user = userhead;
   while(user != NULL)
   {
      if(!strcasecmp(nick, user->nick))
      {
		nuser=conv_char(user->nick);
        snprintf(buff, 100, "database/usr/%s", nuser);
        strlwr(buff);
        if(!(fp1 = fopen(buff, "w"))) return;

        fprintf(fp1, "NICK %s %s %d %d %d %d %s\n", user->nick, user->passwd, user->level, user->setkill, user->lastseend, user->suspendu, user->mail);

        fclose(fp1);
        return;
      }
      user = user->next;
   }
}

void write_users()
{
   struct userinfo *user;
   FILE *fp1;
   char *nuser = NULL, buff[100];

   buff[0] = '\0';

   user = userhead;
   while(user != NULL)
   {
      nuser=conv_char(user->nick);
      snprintf(buff, 100, "database/usr/%s", nuser);
      strlwr(buff);
      if(!(fp1 = fopen(buff, "w"))) return;

      fprintf(fp1, "NICK %s %s %d %d %d %d %s\n", user->nick, user->passwd, user->level, user->setkill, user->lastseend, user->suspendu, user->mail);

      fclose(fp1);
      user = user->next;
   }
}

void write_badchans()
{
   FILE *fp;
   struct badchans *badchan;

   if(!(fp = fopen(BADCHANS_FILE, "w"))) return;

   badchan = badchead;
   while(badchan != NULL)
   {
      fprintf(fp, "%s :%s\n", badchan->chaine, badchan->raison);
      badchan = badchan->next;
   }
   fclose(fp);
   return;
}

void load_badchans()
{
   FILE *fp;
   char buff[300], *chaine, *raison = NULL;

   if(!(fp = fopen(BADCHANS_FILE, "r"))) return;
   while(fgets(buff, 300, fp) != NULL)
   {
	   strip_newline(buff);
	   if((raison = strchr(buff, ':'))) *raison++ = '\0';
	   chaine = strtok(buff, " ");
	   add_abadchan(chaine, raison);
   }
   fclose(fp);
}

void write_cmds()
{
	FILE *fp;
	int i = 0;

	if(!(fp = fopen(CMDS_FILE, "w"))) return;

	while(uw_cmds[i].cmd[0] != '\0')
	{
		if(uw_cmds[i].cmd[0] != '\001')
		fprintf(fp, "%s %s %d %d %d\n", uw_cmds[i].realcmd[0] != '\0' ? uw_cmds[i].realcmd : uw_cmds[i].cmd, uw_cmds[i].cmd, uw_cmds[i].level ,uw_cmds[i].disable, uw_cmds[i].used);
		i++;
	}
}

void load_cmds()
{
	FILE *fp;
	char buff[500], realcmd[15], cmd[15];
	int level, enable, c = 0, used;

	if(!(fp = fopen(CMDS_FILE, "r"))) return;
	while(fgets(buff, 100, fp) != NULL)
	{
		strip_newline(buff);
		sscanf(buff, "%s %s %d %d %d",realcmd, cmd, &level, &enable, &used);
		while(uw_cmds[c].cmd[0] == '\001')
			c++;
		if(!strcasecmp(uw_cmds[c].cmd, realcmd))
		{
			strcpy(uw_cmds[c].cmd, cmd);
			strcpy(uw_cmds[c].realcmd, realcmd);
			uw_cmds[c].level = level;
			uw_cmds[c].disable = enable;
			uw_cmds[c].used = used;
			c++;
		}
	}
}

void rehash_conf(aNick *nick, int parc, char **parv)
{
	if (load_config(FICHIER_CONF)== (-1))
	{
		uwntc(nick->numeric, "Impossible d'ouvrir la configuration");
		uwntc(nick->numeric, "Il est possible qu'une erreur ai t faite dans la configuration, vrifiez.");
		return;
	}
	uwntc(nick->numeric, "Configuration actualise avec succs");
	return;
}
