/* src/mkpasswd.c - Cryptage des mots de pass
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <time.h>
#include <main.h>

CVSINFO("$Id: mkpasswd.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

char *crypt(const char *key, const char *salt);

char *mkpass(char *password, char *keys)
{
   static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
   char salt[3];

   if (strlen(keys) < 2) {
      srandom(time(0));
      salt[0] = saltChars[random() % 64];
      salt[1] = saltChars[random() % 64];
      salt[2] = 0;
   }
   else {
      salt[0] = keys[0];
      salt[1] = keys[1];
      salt[2] = '\0';
      if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
         fprintf(stderr, "illegal salt %s\n", salt), exit(1);
   }
   if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
      fprintf(stderr, "illegal salt %s\n", salt), exit(1);

   return (crypt(password, salt));
}
