/* src/ns_register.c - Enregistrer son pseudo sur nickserv
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include <time.h>
#include <stdarg.h>
#include <main.h>

CVSINFO("$Id: register.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

/*
 * set_kill
 *
 * parv[1] = on/off
 */
void set_kill(aNick *nick, int parc, char **parv)
{
	if(!IsAuthed(nick))
	{
		uwntc(nick->numeric, "Vous devez tre identifi");
		return;
	}
	if(!parc) nick->user->setkill = nick->user->setkill ? 0 : 1;
	else
	{
		if(!strcasecmp(parv[1], "ON"))
			nick->user->setkill = 1;
		else if(!strcasecmp(parv[1], "OFF"))
			nick->user->setkill = 0;
		else
		{
			uwntc(nick->numeric, "La valeur doit tre ON ou OFF");
			return;
		}
	}
	uwntc(nick->numeric, "Le SETKILL est maintenant %sactiv", nick->user->setkill ? "" : "des");
	write_anuser(nick->user->nick);
	return;
}
#undef RAND_MAX
#define RAND_MAX 99999999
void check_kills()
{
	aKill *current, *next;
	char buff[NICKLEN];

	if(!kill_interval) return;
	for(current = killhead;current;current=next)
	{
		next=current->next;
		if(time(NULL) >= (current->timestamp + kill_interval) && getnickbynick(current->nick))
		{
			if(changenick && current->why == 2)
			{
				snprintf(buff, NICKLEN, "%s%02d", CHNICKRAND, rand());
				putserv(":%s SVSNICK %s :%s\n", uw.nick, current->numeric, buff);
			}
			else
			{
				putserv(":%s KILL %s :%s (%s)\n", uw.nick, current->numeric, uw.nick, (current->why == 1) ? "Pseudo illgal" : "Pseudo enregistr");
				del_killinfo(current->nick, current->numeric);
				del_nickinfo(current->numeric);
			}
		}
	}
}

void uwwall(const char *msg, ...)
{
	aNick *n;
	char buf[512];
	va_list vl;
	va_start(vl, msg);
	vsnprintf(buf, 512, msg, vl);
	va_end(vl);

	for(n=nickhead;n;n=n->next) if(n->user && n->user->level > 1) uwntc(n->numeric, buf);
	return;
}

void hello_world(aNick *nick, int parc, char **parv)
{
	struct userinfo *user;
	char passwd[20], x[1], p[15];
	x[0] = '\0';

	if(!premiere)
	{
		uwntc(nick->numeric, "Hello ! L'owner des services a dj t dfini");
		return;
	}
	if(parc < 2)
	{
		uwntc(nick->numeric, "La syntaxe est: /%s HELLO <login> <mail> <pass>", uw.nick);
		return;
	}
	strncpy(p, parv[3], 15);
	if(strlen(p) < 6)
	{
		uwntc(nick->numeric, "Le pass doit faire entre 6 et 15 caractres.");
		return;
	}
	if ((user = getuserinfo(parv[1])))
	{
		uwntc(nick->numeric, "%s est dj un UserName enregistr. (Dernire visite il y a %s)", user->nick, duration(time(NULL) - user->lastseend));
		return;
	}
	if(nick->user)
	{
		uwntc(nick->numeric, "Vous tes dj identifi sous l'username \002%s\002, et vous ne pouvez avoir plus d'un username.", nick->user);
		return;
	}
	if(strlen(parv[2]) > 140)
	{
		uwntc(nick->numeric, "Le mail est limit  140 charactres.");
		return;
	}
	if(!strchr(parv[2], '@') || !strchr(parv[2], '.'))
	{
		uwntc(nick->numeric, "Veuillez entrer un email correct.");
		return;
	}
	strcpy(passwd, mkpass(p, "lala"));

	add_regnick(parv[1], passwd, time(NULL), 4, 0, 0, parv[2]);
	uwntc(nick->numeric, "Hello ! Vous tes bien reconnu comme administrateur de l'uworld CoderZ");
	uwntc(nick->numeric, "Vous tes de niveau 4, le niveau le plus lev des admins !");
	uwntc(nick->numeric, "Ce robot permet de faire des oprations avec un serveur.");
	uwntc(nick->numeric, "Vous pouvez vous identifier avec /msg %s LOGIN %s <pass>", uw.nick, parv[1]);
	write_userlist();
	write_anuser(parv[1]);
	premiere = 0;
	return;
}

void ns_newpass(aNick *nick, int parc, char **parv)
{
	char p[15];
	if(!parc)
	{
		uwntc(nick->numeric, "Syntaxe: NEWPASS <pass>");
		return;
	}
	strncpy(p,parv[1],15);
	if(strlen(p) < 6)
	{
		uwntc(nick->numeric, "Le pass doit faire entre 6 et 15 caractres.");
		return;
	}
	strcpy(nick->user->passwd, mkpass(p, "lala"));
	uwntc(nick->numeric, "\002Votre pass a bien t chang\002");
	write_anuser(nick->user->nick);
	return;
}

#undef RAND_MAX
#define RAND_MAX 23456789
/*
 * oubli_pass
 *
 * parv[1] = login
 * parv[2] = mail
 */
void oubli_pass(aNick *nick, int parc, char **parv)
{
	FILE *fm;
	anUser *user;
	char passwd[15], mail[100], dir[50];

	dir[0]='\0';
	mail[0]='\0';
	if(parc < 2)
	{
		uwntc(nick->numeric, "Syntax: OUBLI <username> <mail>");
		return;
	}
	if(!strcasecmp(mailprog, "nomail"))
	{
		uwntc(nick->numeric, "La commande est pour le moment desactive.");
		uwntc(nick->numeric, "Si vous avez oubli votre pass, demandez  un admin (\002/%s admin\002) de le changer", uw.nick);
		return;
	}
	if(nick->user)
	{
		uwntc(nick->numeric, "Vous tes dj identifi sur un username");
		return;
	}
	if(!(user = getuserinfo(parv[1])))
	{
		uwntc(nick->numeric, "\002L'username %s existe pas !\002", parv[1]);
		return;
	}
	if(strcasecmp(user->mail, parv[2]))
	{
		uwntc(nick->numeric, "Le mail de l'account %s n'est pas %s", user->nick, parv[2]);
		return;
	}
	if(user->nick[0] % 2)
		snprintf(passwd, 15, "np%02dl", rand());
	else
		snprintf(passwd, 15, "pr%02dh", rand());
	strcpy(user->passwd, mkpass(passwd, "lala"));
	sprintf(dir, "database/%s.mail", user->nick);
	if(!(fm = fopen(dir, "w")))
	{
		uwntc(nick->numeric, "Impossible d'envoyer le mail");
		return;
	}
	fprintf(fm, "Subject: %s @ %s - Mot de passe oubli", uw.nick, network);
	fprintf(fm, "\n\n");
	fprintf(fm, "Cher(e) %s\n", user->nick);
	fprintf(fm, "\nVotre mot de passe sur %s est maintenant : %s\n", uw.nick, passwd);
	fprintf(fm, "\nVeuillez le conserver.\nPour vous identifier tapez : /%s login %s %s\n", uw.nick, user->nick, passwd);
	fprintf(fm, "Si vous voulez le changer, tapez: /%s newpass <pass>\n", uw.nick);
	fprintf(fm, "\n\n%s, UWorld CoderZ de %s\n", uw.nick, network);
	fclose(fm);
	sprintf(mail, "%s -f \"Services d'%s\" %s < %s\n", mailprog, network, user->mail, dir);
	printf("%s\n", mail);
	system(mail);
	sprintf(mail, "rm %s", dir);
	system(mail);
	uwntc(nick->numeric, "Le nouveau pass vient d'tre envoy par mail  %s", parv[2]);
	write_anuser(user->nick);
	return;
}


void drop_user(aNick *nick, int parc, char **parv)
{
	char fichier[230], *thenick = NULL, p[15];

	if(!nick->user)
	{
		uwntc(nick->numeric, "Accs refus. Vous devez tre identifi pour DROP votre Username.");
		return;
	}
	if(parc < 1)
	{
		uwntc(nick->numeric, "Syntax: DROP <pass>");
		return;
	}
	if(nick->user->want_to_drop)
	{
		if(!strcasecmp(parv[1], "OUI"))
		{
			uwntc(nick->numeric, "Votre UserName (%s) a t supprim, ainsi que tout vos accs/mmos.", nick->user->nick);

			thenick = conv_char(nick->user->nick);
			snprintf(fichier, 100, "database/usr/%s", thenick);
			remove(fichier);
			putserv(":%s SVSMODE %s -r\n", uw.nick, nick->numeric);
			write_userlist();
			del_regnick(nick->user->nick);
			nick->user = NULL;
		}
		else if(!strcasecmp(parv[1], "NON"))
		{
			uwntc(nick->numeric, "Votre username ne sera donc pas supprim");
			nick->user->want_to_drop = 0;
		}
		else
		{
			uwntc(nick->numeric, "Voulez vous rellement supprimer votre username ?");
			uwntc(nick->numeric, "Rponse : /z drop oui/non");
		}
		return;
	}
	else
	{
		strncpy(p,parv[1],15);
		if (!strcmp(mkpass(p, "lala"), nick->user->passwd))
		{
			uwntc(nick->numeric, "Voulez vous rellement supprimer votre username ?");
			uwntc(nick->numeric, "\002ATTENTION :\002 La suppression de votre username se rsulte  supprimer tous vos memos, vos access et votre salon. Vous ne pouvez \002PAS\002 revenir en arrire ");
			uwntc(nick->numeric, "Rponse : /z drop oui/non");
			nick->user->want_to_drop = 1;
		}
		else
			uwntc(nick->numeric, "\002Mot de passe invalide !");
	}

	return;
}

void ns_login(aNick *nick, int parc, char **parv)
{
	anUser *user = NULL;
	char p[15];
	if(parc < 2)
	{
		uwntc(nick->numeric, "La syntaxe est /%s LOGIN <username> <pass>", uw.nick);
		return;
	}
	if(!(user = getuserinfo(parv[1])))
	{
		uwntc(nick->numeric, NOSUCHUSER, parv[1]);
		return;
	}
	if(nick->user)
	{
		uwntc(nick->numeric, "Vous tes dj identifi sous l'username \002%s\002, et vous ne pouvez avoir plus d'un username.", nick->user->nick);
		if(user->level > 1 && user->nick != nick->user->nick)
		{
			uwwall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s@%s\n", user->nick, user->level, user->mail, nick->nick, nick->user->nick);
		}
		return;
	}
	if(user->authed)
	{
		uwntc(nick->numeric, "Quelqu'un est dj identifi sur cet username");
		if(user->level > 1)
		{
			uwwall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}
	if(user->suspendu)
	{
		uwntc(nick->numeric, "Votre Username est suspendu, soit par scurit, soit par les Admins, consultez votre e-mail pour connaitre votre nouveau pass");
		if(user->level > 1)
		{
			uwwall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}
	strncpy(p,parv[2],15);
	if (strcmp(mkpass(p, "lala"), user->passwd))
	{
		uwntc(nick->numeric, "\002Mot de pass incorrect !\002");
		uwntc(nick->numeric, "Si vous ne vous en rappelez plus, utilisez : \002 /%s oubli %s <mail>\002", uw.nick, user->nick);
		if(user->level > 1)
		{
			uwwall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

	nick->user = user;
	nick->user->authed = 1;
	nick->user->lastseend = time(NULL);
	del_killinfo(nick->nick, nick->numeric); // arret du kill, vu ke c son nick !
	uwntc(nick->numeric, "Login \002russi\002 pour %s, vous avez dsormais accs  %s", nick->user, uw.nick);
	uwntc(nick->numeric, "\002Vous tes identifi en tant qu'admin niveau %d", nick->user->level);
	uwntc(nick->numeric, "Pour joindre le salon d'information, tapez /msg %s INVITEME", uw.nick);
	return;
}

void chmail(aNick *nick, int parc, char **parv)
{
	struct userinfo *users;
	if(strlen(parv[1]) > 148)
	{
		uwntc(nick->numeric, "Le mail est limit  148 charactres.");
		return;
	}
	if(!strchr(parv[1], '@') || !strchr(parv[1], '.'))
	{
		uwntc(nick->numeric, "Veuillez entrer un email correct.");
		return;
	}
	if(!strcasecmp(nick->user->mail, parv[1]))
	{
		uwntc(nick->numeric, "%s est dj votre mail enregistr.", parv[1]);
		return;
	}

	users=userhead;
	while(users && strcasecmp(users->mail, parv[1])) users = users->next;
	if(users)
	{
		uwntc(nick->numeric, "Ce mail est dj utilis.");
		return;
	}

	strcpy(nick->user->mail, parv[1]);
	write_anuser(nick->user->nick);
	uwntc(nick->numeric, "Votre mail a t chang en \002%s", nick->user->mail);
	return;
}

