/* src/serveur.c - Fonctions serveur
 * Copyright (C) 2002 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <ctype.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/socket.h>
#include "main.h"

struct aServ servtab[64];

CVSINFO("$Id: serveur.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

struct aMsg msgtab[] = {
  {"PRIVMSG", m_privmsg},
  {"PING", m_ping},
  {"NICK", m_nick},
  {"JOIN", m_join},
  {"PART", m_part},
  {"MODE", m_mode},
  {"KICK", m_kick},
  {"CREATE", m_create},
  {"QUIT", m_quit},
  {"BURST", m_burst},
  {"AWAY", m_away},
  {"005", m_005},
  {"007", m_007},
  {"SERVER", m_server},
  {"SQUIT", m_squit},
  {"KILL", m_kill},
  {"WHOIS", m_whois},
 // {"VERSION", m_version},
  {"ADMIN", m_version},
  {"SETHOST", m_sethost},
  {"SETIDENT", m_setident},
  {"PASS", m_pass},
  {"END_OF_BURST", m_eob},
  {NULL, NULL}
};

void m_version(int sock, int parc, char **parv)
{
	//printf("%s\n", parv[1]);
	return;
	return putserv(":%s 402 %s :Services CoderZ %s  Inter System", parv[1], SPVERSION);
}

/*
 * m_mode
 *
 * parv[0] = who
 * parv[1] = chan
 * parv[2] = modes
 * parv[3->parc-1] = rest
 */
void m_mode(int sock, int parc, char **parv)
{
	aJoin *join;
	aNick *nick;
	char *modes = NULL, *param = NULL, tmp[200];
	int what = 1, i = 2, is_chan = 0;

	if(parc > 2)
	{
		tmp[0]='\0';
		if(parv[1][0] == '#')
		{
			is_chan = 1;
		}
		modes = parv[2];
		while (modes && *modes)
		{
			switch (*modes)
			{
				case '+':
					what = 1;
					break;
				case '-':
					what = 0;
					break;
				case 'o':
					if(is_chan)
					{
						char *nick = NULL;
						do
						{
							i++;
							param = parv[i];
						}
						while(!*param || !param);
						nick = num2nick(param);
						strcat(tmp, " ");
						strcat(tmp, nick);
						if(!what && !strcmp(uw.num, param))
						{/*deop du robot*/
							uwmode(parv[1], "+o %s", uw.num);
							break;
						}
						if((join = getjoininfo(nick, parv[1]))) // le num2nick  permis ici non ?
							join->is_op = what ? 1 : 0;
					}
					else if((nick = getnickbynick(parv[1])))
							nick->is_oper = what ? 1 : 0;
					break;
				case 'v':
					if(is_chan)
					{
						char *nick = NULL;
						do
						{
							i++;
							param = parv[i];
						}
						while(!*param || !param);
						nick = num2nick(param);
						if((join = getjoininfo(nick, parv[1]))) // le num2nick  permis ici non ?
							join->is_voice = what ? 1 : 0;
						strcat(tmp, " ");
						strcat(tmp, nick);
					}
					break;
				case 'b':
				    do  /*l on modifie 'i' pour qu'il passe au paramtre de ce mode, pour pas ke celui du suivant soit celui ci, hein cesar*/
				    {
				    	i++;
				    	param = parv[i];
				    }
				    while(!*param || !param);
				    strcat(tmp, " ");
					strcat(tmp, parv[i]);
					break;
				case 'l':
					if(what)
					{
						i++;
						strcat(tmp, " ");
						strcat(tmp, parv[i]);
					}
					break;
				case 'k':
					i++;
					strcat(tmp, " ");
					strcat(tmp, parv[i]);
					break;
			}
			modes++;
		}
		if(!is_chan && (nick = getnickbynick(parv[1]))) strncpy(nick->modes, parv[2], 10);
		putchan("\002MODE\002 %s %s%s par %s", parv[1], parv[2], tmp, parv[0]);
	}
	return;
}

/*
 * m_part
 *
 * parv[0] = nick
 * parv[1] = chans
 * parv[2] = raison
 */
void m_part(int sock, int parc, char **parv)
{
  char *nick = NULL, *p;
  int i = 1;

  if(parc < 2) return;
  nick = parv[0];
  if(parc > 2)
  	putchan("\2PART\2 %s par %s (%s)", parv[1], parv[0], parv[2]);
  else
	putchan("\2PART\2 %s par %s", parv[1], parv[0]);
  p = strtok(parv[1], ",");
  while(p != NULL && i < 11)
  {
	  del_join(nick, p);
	  i++;
	  p = strtok(NULL, ",");
  }

  return;
}

/*
 * m_kick
 *
 * parv[0] = kickeur fou
 * parv[1] = chan
 * parv[2] = num victime
 * parv[3] = raison
 */
void m_kick(int sock, int parc, char **parv)
{
  aNick *v;

  if(parc < 3) return;
  v=nickhead;
  while(v && strcmp(v->numeric,parv[2])) v=v->next;
  if(!v) return;
  putchan("\2KICK\2 %s %s par %s (%s)", parv[1], v->nick, parv[0], parv[3]);
  del_join(v->nick, parv[1]);
  return;
}

/*
 * m_join
 *
 * parv[0] = nick
 * parv[1] = chans
 */
void m_join(int sock, int parc, char **parv)
{
  char *nick = NULL, *p;
  int i = 1;

  if(parc < 2) return;
  nick = parv[0];
  if(strchr(nick, '@')) return;
  putchan("\2JOIN\2 %s par %s", parv[1], parv[0]);
  p = strtok(parv[1], ",");
  while(p != NULL && i < 11)
  {
	  add_join(nick, p, 0, 0, time(NULL), 0);
	  i++;
	  p = strtok(NULL, ",");
  }

  return;
}

/*
 * m_create
 *
 * parv[0] = num
 * parv[1] = chan
 * parv[2] = timestamp
 */
void m_create(int sock, int parc, char **parv)
{
  char *nick = NULL, *p;
  int i = 1;

  if(parc < 3) return;
  nick = num2nick(parv[0]);
  putchan("\2JOIN\2 %s par %s (Create)", parv[1], nick);
  p = strtok(parv[1], ",");
  while(p != NULL && i < 11)
  {
	  add_join(nick, p, 1, 0, atol(parv[2]), 0);
	  i++;
	  p = strtok(NULL, ",");
  }
  return;
}

/*
 * m_setident
 *
 * parv[0] = num
 * parv[1] = host
 */
void m_setident(int sock, int parc, char **parv)
{
	aNick *who;
	
	if(parc<2) return;
	who = nickhead;
	while(who)
	{
		if(!strcmp(who->numeric, parv[0]))
		{
			strncpy(who->ident, parv[1], USERLEN);
			return;
		}
		who = who->next;
	}
	return;
}

/*
 * m_sethost
 *
 * parv[0] = num
 * parv[1] = host
 */
void m_sethost(int sock, int parc, char **parv)
{
	aNick *who;

	if(parc<2) return;
	who = nickhead;
	while(who)
	{
		if(!strcmp(who->numeric, parv[0]))
		{
			if((strchr(parv[1], ':'))) return;
#ifdef HAVE_CRYPTHOST
			strncpy(who->crypt, parv[1], HOSTLEN);
#else
			strncpy(who->host, parv[1], HOSTLEN);
#endif
			return;
		}
		who = who->next;
	}
	return;
}

/*
 *m_nick
 *
 * parv[1] = nick
 * parv[2] = hop
 * parv[3] = timestamp
 * parv[4] = username
 * parv[5] = host
 *  ==[ user a un/des mode(s) | user a pas de mode ]==
 * parv[6] = modes | base64
 * parv[7] = base64 | num
 * parv[8] = num | name
 * parv[9] = name |
 */
void m_nick(int sock, int parc, char **parv)
{
	char *server, *ident, *name = NULL;
	char *nick, *host, *num, *hop, *lastnick = NULL, *crypt = NULL, key[32], *modes = NULL;
	aNick *who = NULL;
	anUser *user;
	/*int i;cf plus bas*/

	if(parc > 7)
	{  /*Nouveau nick*/
		int nbclones = 0;
		char clones[500];
		clones[0]='\0';
		ident = parv[4];
		if(*ident == '~') ident++;
		host = parv[5];
		nick = parv[1];
		hop = parv[2];
		key[0]='\0';
#ifdef HAVE_CRYPTHOST
		if(strchr(host, '.')) /* la clef est la premire partie de l'host*/
		{
			strncpy(key, host, 32);
			strtok(key, ".");
			crypt = hostprot(key, host); /* cryptage de l'host en md2 ou md5 suivant certains critres*/
		}
#endif
		if(parv[6][0] == '+')
		{  /* L'user a un/des mode(s)*/
			server = num2serv(*parv[8]);
			num = parv[8];
			modes = parv[6];
			name = parv[9];
#ifdef HAVE_CRYPTHOST
			add_nickinfo(parv[1], ident, host, crypt, parv[7], parv[8], server, name, atol(parv[3]), parv[6]);
#else
			add_nickinfo(parv[1], ident, host, parv[7], parv[8], server, name, atol(parv[3]), parv[6]);
#endif

		}
		else
		{  /* L'user n'a pas de modes*/
			server = num2serv(*parv[7]);
			num = parv[7];
			name = parv[8];
#ifdef HAVE_CRYPTHOST
			add_nickinfo(parv[1], ident, host, crypt, parv[6], parv[7], server, name, atol(parv[3]), "");
#else
			add_nickinfo(parv[1], ident, host, parv[6], parv[7], server, name, atol(parv[3]), "");
#endif
		}
		for(who=nickhead;who;who=who->next)
			if(!strcasecmp(who->host, host))
			{
				nbclones++;
				if(clones[0]!='\0') strcat(clones, " ");
				strcat(clones, who->nick);
				if(nbclones>=clonenb) break;
			}
		putchan("\2NICK\2 %s %s@%s (%s Clones: \2[%d]\2)", parv[1], ident, host, server, nbclones);
		if(nbclones>1) putchan("*** Clones \2[%d]\2 %s : %s", nbclones, host, clones);
		if(nbclones>=clonewar && nbclones<clonenb)
			uwntc(num, "\2ATTENTION\2: Vous avez %d clones (%s). Si vous apportez encore %d clones vous allez vous faire bannir du serveur", nbclones, clones, (clonenb - nbclones));
		if(nbclones>=clonenb)
			putserv(":%s GLINE * *@%s %d :Pas tant de clones !\n", bot.server, host, clonetmp);
	}
	else
	{  /* Changement de pseudo */
		nick = parv[1];
		num = parv[0];
		who = nickhead;
		while(who)
		{
			if(!strcmp(who->numeric, parv[0]))
			{
				del_killinfo(who->nick, num);/*on evite le nick2num hin progs ;)*/
				lastnick = who->nick;
				strcpy(who->nick, nick);
				break;/*on la trouv, on exit la loop, hin progs:)*/
			}
			who = who->next;
		}
		putchan("\2NICK\2 %s -> %s", lastnick, nick);
	}
	if(!who)/*on refait pas la loop.. hin progs;)*/
	{
		who = nickhead;
		while(who && strcmp(who->numeric, num)) who = who->next;
	}
#ifdef HAVE_AUTOKILL
	if(who->user && !strcasecmp(who->user->nick, nick)) return;/*le mec est auth sur ce nick > exit anyway :)*/
	if(!(user = getuserinfo(nick)) || (modes && strchr(modes, 'r'))) return;/*le pseudo n'est pas reg, on evite leisregnick(//boucle)> exit :)*/
	uwntc(num, "\002Avertissement\002 : Le pseudo %s appartient  un administrateur", nick, uw.nick, nick);
	if(user->setkill)
	{
		if(!changenick) uwntc(num, "Veuillez changer de pseudo sinon vous serez dconnect dans %d secondes.", kill_interval);
		else uwntc(num, "Veuillez changer de pseudo sinon votre pseudo sera automatiquement chang dans %d secondes.", kill_interval);
		add_killinfo(nick, num, time(NULL), 2);
	}
	else uwntc(num, "Il peut le rcuprer en vous dconnectant.");
#endif
	return;
}

/*
 * m_burst
 *
 * parv[0] = num
 * parv[1] = chan
 * parv[2] = timestamp
 * parv[3] = modes / users
 * parv[4] = users / bans
 * parv[5] = bans
 */
void m_burst(int sock, int parc, char **parv)
{
  char *modes = NULL, *chan = parv[1], *timestamp = parv[2], *users = NULL, *nick = NULL;
  char *flags = NULL, *num = NULL, *pv = NULL/*, *bans = NULL*/;
  int op = 0, voiced = 0, i=4;

  if(parc > 2 && parv[3][0] == '%') return;
  //printf("%s %s\n", parv[2], parv[3]);

if(parc > 4 && parv[3][0] == '+')
  {  /* channel has mode(s) */
	add_burst(parv[1], parv[3], atoi(parv[2]));
	modes = parv[3];
	if(strchr(modes, 'l')) i++;
	if(strchr(modes, 'k')) i++;
	users = parv[i];
	/*if(parc > i) bans = parv[++i];*/
  }
  else
  {  /* channel has no mode */
	add_burst(parv[1], "", atoi(parv[2]));
	modes = "";
	users = parv[3];
	/*if(parc > 4) bans = parv[4];*/
  }
  pv=users;
  while((num=strtok(pv, ",")))
  {
	if((flags = strchr(num, ':')))
	{
		op=0;
		voiced=0;
		*flags = '\0';
		while (*(++flags))
			if (*flags == 'o')
			  op = 1;
			else if (*flags == 'v')
			  voiced = 1;
			else
			  break;
	}
	nick = num2nick(num);
	add_join(nick, chan, op, voiced, atol(timestamp), 1);
	pv=NULL;
  }
 /* if(bans)
  {
  	  bans++;
	  bans++;
	  pv=bans;
	  while((mask=strtok(pv, " ")))
	  {
	        add_ban(chan, mask, "Aucune", "MODE", time(NULL), 0, 0);
	  	pv=NULL;
	  }
  }*/
  return;
}

/*
 * m_quit
 *
 * parv[0] = nick
 * parv[1] = msg
 */
void m_quit(int sock, int parc, char **parv)
{
	aNick *nick;
	char *num = NULL;

	nick = nickhead;
	while (nick)
	{
		if(!strcasecmp(nick->nick, parv[0]))
		{
			if(nick->user) nick->user->authed = 0;
			num = nick->numeric; /*on evite le nick2num hin progs:)*/
			break;
		}
		nick = nick->next;
	}
	del_nickinfo(num);
	putchan("\2QUIT\2 de %s :%s", parv[0], parv[parc-1]);
	if(getuserinfo(parv[0])) del_killinfo(parv[0], num);
	return;
}

/*
* m_kill
*/

void m_kill(int sock, int parc, char **parv)
{
	char *num = parv[1], *nick;

	if(!(nick = num2nick(num))) return;
	del_nickinfo(num);
	putchan("\2KILL\2 %s par %s (%s)", nick, parv[0], parv[parc-1]);
	if(getuserinfo(nick)) del_killinfo(nick, num);
	return;
}

/*
 * m_away
 *
 * parv[0] = who
 * parv[1-parc] = raison
 */
void m_away(int sock, int parc, char **parv)
{
	aNick *nick;

	if(!(nick = getnickinfo(parv[0]))) return;
	if(parc>1) nick->away = 1;
	else nick->away = 0;
	return;
}

/*
 * m_whois
 *
 * parv[0] = who
 * parv[1] = ma num
 * parv[2] = pseudo du robot
 */
void m_whois(int sock, int parc, char **parv)
{
	if(!strcasecmp(parv[2], uw.nick))
		putserv(":%s 311 %s %s %s %s * :%s\n", bot.server, parv[0], uw.nick, uw.ident, uw.host, uw.name);
	else    
		putserv(":%s 311 %s %s %s %s * :%s\n", bot.server, parv[0], parv[2], "scoderz", bot.server, bot.name);
	putserv(":%s 312 %s %s %s :%s\n", bot.server, parv[0], parv[2], bot.server, bot.name);
	putserv(":%s 390 %s %s :est un Robot\n", bot.server, parv[0], parv[2]);
	putserv(":%s 313 %s %s :est un IRC Oprateur - Service\n", bot.server, parv[0], parv[2]);
	putserv(":%s 317 %s %s %ld %ld :Secondes d'idle, secondes d'uptime\n", bot.server, parv[0], parv[2], time(NULL) - tidle, tuptime);
	putserv(":%s 318 %s %s :Fin de la commande /WHOIS\n", bot.server, parv[0], parv[2]);
	return;
}

// End of map, I have save it :)
void m_007(int sock, int parc, char **parv)
{
   end_map = 1;
   return;
}

/*
 * m_005
 *
 * parv[0] = server who send
 * parv[1] = me
 * parv[2] = the map :)
 */
void m_005(int sock, int parc, char **parv)
{
   char nmap[100];

   if(parc<3 || end_map) return;
   strncpy(nmap, parv[2], 100);
   add_mapinfo(nmap);
   return;
}

/*
 * m_eob
 *
 * parv[0] = who
 * parv[1] = me :)
 */
void m_eob(int sock, int parc, char **parv)
{
	struct timeval tv;
	int i, gotuw = 0;
	struct burstinfo *bursts;
	float tt;

  i=decode_num(parv[0]);
  if (i == (-1))
  {
    putlog(LOG_ERREURS, "ATTENTION: Prfixe serveur reu incorrect\n");
    return ;
  }
  if (servtab[i].stat != ST_BURST)
  {
    putlog(LOG_ERREURS, "ATTENTION: Erreur interne  m_eob()\n");
    return ;
  }
  servtab[i].stat = ST_ONLINE;
  if (servtab[i].hopcount == 1)
  {
	  if(dataQ)
	  {
		  gettimeofday(&tv, NULL);/*un peu de stats sur le burst pour *fun* */
		  tt= (tv.tv_usec - burst)/1000000.0;
		  if(tt<0) tt= -1*tt;
		  uwwallops("Synchronisation de %d bytes en %12.6f s (Taux %12.6f Ko/s)", dataQ, tt,(float) (dataQ/1024.0)/tt);
		  /*dataQ = 0;*/
	  }
    burst = 0;
    bursts = bursthead;
    while(bursts != NULL)
	{
		if(!strcasecmp(uw.chan, bursts->channel))
		{
			putserv("%s BURST %s %ld +mints %s:o\n", bot.servnum, uw.chan, bursts->chanstamp, uw.num);
			gotuw = 1;
		}

	  bursts = bursts->next;

	}
	if(!gotuw) putserv("%s BURST %s %ld +mints %s:o\n", bot.servnum, uw.chan, time(NULL), uw.num);

    free_burst();
    putserv("%s END_OF_BURST\n", bot.servnum);
    putserv("%s EOB_ACK\n", bot.servnum);
  }
  alarm(ALARMINTERVAL);
  return;
}

void m_server(int sock, int parc, char **parv)
{
  int c, i;

  registered = 1;
  c=decode_num(parv[6]);
  i=c >> 12;

  if (i == -1)
  {
    putlog(LOG_ERREURS, "ATTENTION: Le serveur %s s'est connect avec une numrique invalide.\n", parv[1]);
    return;
  }

  strcpy(servtab[i].name , parv[1]);
  servtab[i].chars = *parv[6];
  servtab[i].hopcount = atoi(parv[2]);
  if (parv[5][0] == 'J')
    servtab[i].stat = ST_BURST;
  else
    servtab[i].stat = ST_ONLINE;

  putchan("\2SERVER\2 %s (%s)", parv[1], parv[parc-1]);
  uwmap();
  return;
}

void m_squit(int sock, int parc, char **parv)
{
  aNick *nick;
  int i;

  if ((i = findserv(parv[1])) == -1) return;

  servtab[i].stat = ST_NOSERV;
  uwmap();
  nick = nickhead;
  while(nick)
  {
     if(!strcasecmp(nick->server, parv[1]))
     {
        if(nick->user != NULL)
		nick->user->authed = 0;
	putchan("\2QUIT\2 de %s :*.net *.split", nick->nick);
        del_nickinfo(nick->numeric);
        nick = nickhead;
     }
     else nick = nick->next;
     if (!nick) break;
  }
  putchan("\2SQUIT\2 de %s", parv[1]);
  return;
}

void m_pass(int sock, int parc, char **parv)
{
	struct timeval tv;

	gettimeofday(&tv, NULL);
	burst = tv.tv_usec;
	putlog(LOG_PARSES, "Connect au serveur %s\n", bot.ip);
	registered = 0;
	if(!tuptime) tuptime = time(NULL);
	if(!lastresetlogs) lastresetlogs = time(NULL);
	if(!lastresetparse) lastresetparse = time(NULL);
	tidle = time(NULL);
	return;
}

void m_ping(int sock, int parc, char **parv)
{
    putserv("%s PONG %s\n", bot.servnum, parv[1]);
    return;
}

void exec_cmd(int i, int securise, aNick *nick, int parc, char **parv)
{
	char *nwho = NULL, *tmp3 = NULL, buff[512];

	nwho = nick->numeric;

	tmp3 = parv2msg(parc, parv, 1);

	uw_cmds[i].used++;

	if(parc < uw_cmds[i].args)
	{
		syntax_cmd(uw.nick, nwho, uw_cmds[i].cmd);
		return;
	}
	if(isignore(nick) || checkflood(nick)) return;
	if(uw_cmds[i].level)
	{
		if(!nick->user || !nick->user->authed)
			uwntc(nwho, "%s : Vous n'tes pas logu ou vous n'avez pas encore enregistr d'Username", pasdeperm);
		else if(uw_cmds[i].level > 0 && nick->user->level < uw_cmds[i].level)
			uwntc(nwho, "%s : Votre niveau n'est pas assez grand pour utiliser cette commande", pasdeperm);
		else
			goto suite;
		return;
	}
	suite:
	if(uw_cmds[i].disable && strcasecmp(uw_cmds[i].realcmd, "DISABLE")) uwntc(nwho, "\002La commande %s est dsactive.", uw_cmds[i].cmd);
	//else if(uw_cmds[i].level && !nick->user->authed) uwntc(nick->numeric, pasdeperm);
	else
	{
		char tmp[NICKLEN*2];

		snprintf(tmp, NICKLEN*2, "%s%c%s", nick->nick, nick->user ? '@' : ' ', nick->user ? nick->user->nick : "");
		if(uw_cmds[i].secure && parc && strcasecmp(uw_cmds[i].realcmd, "NEWPASS")) sprintf(buff, "\002%s\002 %s par %s", uw_cmds[i].cmd, parv[1], tmp);
		else if(uw_cmds[i].secure && parc && !strcasecmp(uw_cmds[i].realcmd, "NEWPASS")) sprintf(buff, "\002%s\002 par %s", uw_cmds[i].cmd, tmp);
		else if(parc > 2 && !strcasecmp(uw_cmds[i].realcmd, "NEWPASS")) sprintf(buff, "\002%s\002 %s par %s", uw_cmds[i].cmd, parv[2], tmp);
		else if(parc) sprintf(buff, "\002%s\002 %s par %s", uw_cmds[i].cmd, tmp3, tmp);
		else sprintf(buff, "\002%s\002 par %s", uw_cmds[i].cmd, tmp);

		putchan(buff);
		putlog(LOG_CMDS, "%s\n", buff);
		uw_cmds[i].func(nick, parc, parv);
	}
	return;
}

/*
 * m_privmsg
 *
 * parv[0] = envoyeur
 * parv[1] = destinataire (pseudo du robot, set dans botnick)
 * parv[2] = message reu.
 *
 * pparv[0] = robot qui a reu le message
 * pparv[pparc] = arguments de la commande
 * ATTENTION: pparc est le nb d'arg  partir de *parv[1]*
 */
void m_privmsg(int sock, int parc, char **parv)
{
	char *tmp, *nwho = NULL, *cmd = NULL, *botnick = NULL;
	char *pparv[500], tmp2[500];
	int i = 0, pparc = 0, securise = 0;
	aNick *nick;

	tmp2[0]='\0';

	nick = nickhead;//la progs jte sauve des xxxxx de loop en 1) l emettant hors du for() 2) en virant le nick2num!!!
	while (nick && strcasecmp(parv[0], nick->nick))  nick = nick->next;
	if(!nick) return;/*emetteur inconnu, on devrait logu ca..*/
	nwho = nick->numeric;

	if(*parv[1] != '#')
	{  // Message envoy  un robot

		pparv[1] = NULL;

		if(strchr(parv[1], '@'))
		{
			botnick = strtok(parv[1], "@");
			securise = 1;
		}
		else botnick = parv[1];

		if(parv[2][1]=='\0' || parv[2][1]==':') return;
		tmp = strtok(parv[2], " ");
		if (tmp != NULL)
		{
			cmd = tmp;
			pparv[0] = uw.nick;
			tmp = strtok(NULL, " ");
		}
		while (tmp != NULL)
		{
			pparc++;
			pparv[pparc] = tmp;
			tmp = strtok(NULL, " ");
		}

		if(strcasecmp("HELLO", cmd) && premiere)
		{
			uwntc(nwho, "%s n'a pas encore t enregistr", uw.nick);
			return;
		}
		if (!strcmp(botnick, uw.num) || !strcasecmp(botnick, uw.nick))
		{
			for (i=0; uw_cmds[i].cmd[0] != '\0'; i++)
				if (((char *)strcasecmp(uw_cmds[i].cmd,cmd))==NULL)
				{
					exec_cmd(i, securise, nick, pparc, pparv);
					return;
				}
			if(*cmd != '\001') uwntc(nwho, "La commande \002%s\002 n'existe pas.", cmd);
		}/*endif*/
		return;
	}
	return;
}

void parse_this(int sock, char *msg)
{
  int parc = 0, i;
  char *ptr, *ptr2, *cmd, logg[512];
  char *parv[MAXPARA + 2 ]; /* leave room for prefix and end-of-params NULL */

#ifdef DEBUG
  printf("READ: %s", msg);
#endif
  strncpy(logg,msg,512);
  dataQ += strlen(msg);/*si en cours de burst, comptage des bytes lues*/

  if(strlen(msg) > 524) return;
  i=strlen(msg)-1;
  if (msg[i] == '\n') msg[i] = 0;
  i=strlen(msg)-1;
  if (msg[i] == '\r') msg[i] = 0;
  ptr = strchr(msg, ' ');
  if (!ptr)
  {
    return;
  }
  if (msg[0] == ':')
  {
    /* long prefix */
    parv[0] = &msg[1];
    *ptr = '\0';
    ptr++;
  } else if (ptr-msg && strncmp(msg, "SERVER", 6) && strncmp(msg, "PASS",4) && (registered))
  {
    /* numeric prefix */
    parv[0] = msg;
    *ptr = '\0';
    ptr++;
  } else
  {
    /* no prefix */
    parv[0] = bot.server;
    ptr=msg;
  }


  ptr2 = strchr(ptr, ' ');
  cmd = ptr;
  if (ptr2)
  {
    *ptr2 ='\0';
    ptr2++;
    ptr = ptr2;
    for (parc=1; (parc <= MAXPARA) && ptr; parc++)
    {
      ptr2 = strchr(ptr, ' ');
      if (!ptr2)
      {
        if (*ptr == ':') ptr++;
        parv[parc]=ptr;
        break;
      } else
      {
        if (*ptr == ':')
        {
          ptr++;
          parv[parc] = ptr;
          break;
        }
        *ptr2='\0';
        ptr2++;
        if (*ptr == ':')
        {
          ptr++;
          parv[parc] = ptr;
          break;
        }
        parv[parc] = ptr;
        ptr = ptr2;
      }
    }
  } else parc=0;

  parc++;
  parv[parc] = NULL;
  /*etical loging*/
  if(!(parc > 1 && ((!strcasecmp(cmd,"PRIVMSG") && parv[1][0] == '#') ||
         !strcasecmp(cmd, "PING") || !strcasecmp(cmd, "PONG"))))
  putlog(LOG_PARSES, "R - %s", logg);
  /*end */
  for (i=0; msgtab[i].cmd != NULL; i++)
  {
	  if (((char *)strcasecmp(msgtab[i].cmd,cmd))==NULL)
	  {
		  msgtab[i].func(sock, parc, parv);
		  return;/*on sait jamais */
	  }
  }
}

int init_bot(int ip, int port)
{
  int sock;
  int r;
  struct sockaddr_in fsocket;
  int LTS;
  int i;

  for (i=0; i<64; i++)
  {
    servtab[i].stat = ST_NOSERV;
  }
  LTS = time(NULL);
  sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
  if (sock < 0)
  {
    return(-1);
  }
  fsocket.sin_family = AF_INET;
  fsocket.sin_addr.s_addr = ip;
  fsocket.sin_port = htons(port);
  r=connect(sock, (struct sockaddr *) &fsocket, sizeof(fsocket));
  if (r==(-1))
  {
    close(sock);
    return(-1);
  }
  bot.sock = sock;
  putserv("PASS %s\n", bot.pass);
  putserv("SERVER %s 1 %u %u J10 %s%s :%s\n", bot.server, STS, LTS, bot.servnum , "D]" , bot.name);
  putserv("%s NICK %s 1 %u %s %s %s B]AAAB %s :%s\n", bot.servnum, uw.nick, LTS, uw.ident, uw.host, uw.mode, uw.num, uw.name);
#ifdef HAVE_CRYPTHOST
	add_nickinfo(uw.nick, uw.ident, uw.host, uw.host, "B]AAAB", uw.num, bot.server, uw.name, time(NULL), uw.mode);
#else
	add_nickinfo(uw.nick, uw.ident, uw.host, "B]AAAB", uw.num, bot.server, uw.name, time(NULL), uw.mode);
#endif
  return sock;
}

void run_bot(int sock)
{
  int maxi;
  int r;
  int t =0;
  fd_set rfds;
  fd_set wfds;
  char msg[512];
  char buf[1024];
  char c;
  struct timeval tv;
  int next_ping;
  int waitping;

  if (sock < 0 ) return;

  next_ping = time(NULL) + PING_FREQ;
  waitping = 0;

  while (!want_to_quit)
  {

    tv.tv_sec = 1;
    tv.tv_usec = 0;
    FD_ZERO(&rfds);
    FD_ZERO(&wfds);
    FD_SET(sock, &rfds);
    maxi=sock;

   // process_checks(sock, &rfds, &wfds);

    if (!FD_ISSET(sock, &rfds))
    {
      if (next_ping <= time(NULL))
      {
        if (waitping == 0)
        {
          putserv(":%s PING :%s\n", bot.server, bot.server);
          next_ping = time(NULL) + PING_FREQ;
          waitping = 1;
        } else
        {
          printf("Pas de rponse pour %s\n", bot.ip);
          close(sock);
          return;
        }
      }
      continue;
    } else
    {
      r=recv(sock, &c, 1, 0);
      if (r <= 0) break;
      next_ping = time(NULL) + PING_FREQ;
      waitping = 0;

      buf[t] = c;
      t++;
      if (c=='\n')
      {
        buf[t] = '\0';
        strncpy(msg, buf,512);
        parse_this(sock, msg);
        t=0;
      }
    }
  }
  if (want_to_quit)
  {
    close(sock);
    return;
  }
  return;
}
