/* src/showcommands.c - Liste les commandes
 * Copyright (C) 2002 Inter System (Progs@Inter-System.Net)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>
#include <time.h>

CVSINFO("$Id: track.c,v 1.1.1.1 2002/11/03 20:16:59 coderz Exp $");

struct track *istrack(char *user)
{
	struct track *track;
	for(track=trackhead;track && strcasecmp(track->nick,user);track=track->next);
	return track;
}

void add_track(char *nick, char *reqn, char *requ, long expire)
{
	struct track *new, *current;
	new = (struct track *) calloc(1, sizeof(struct track));
	if(new)
	{
		new->next = NULL;
		strcpy(new->reqn,reqn);
		strcpy(new->requ,requ);
		strcpy(new->nick,nick);
		new->expire=expire;
		new->from=time(NULL);
		if(!trackhead) trackhead = new;
		else
		{
			current = trackhead;
			while(current->next) current = current->next;
			current->next = new;
		}
	}
}

void del_track(char *nick)
{
   struct track *current, *previous = NULL, *tmp;

   current = trackhead;
   while(current)
   {
      if(!strcasecmp(nick, current->nick)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(!current) return;
   else
   {
      if(current == trackhead) trackhead = trackhead->next;
      else previous->next = current->next;
      tmp = current->next;
      free(current);
      current = NULL;
   }
}

void cmd_track(struct nickinfo *nick, int parc, char **parv)
{
	if(!strcasecmp(parv[1], "list"))
	{
		struct track *track;
		int i=0;
		if(parc < 2) i=1;
		uwntc(nick->numeric, "\2Liste des Traqus:\2");
		for(track=trackhead;track;track=track->next)
		{
			if(i || !match(parv[2],track->nick))
			{
				uwntc(nick->numeric, "> \2%s\2 (Pour \2%s\2, depuis %s, expire %s)", track->nick, track->reqn, duration(time(NULL) - track->from), !track->expire ? "Jamais" : duration(time(NULL) - track->expire));
			}
		}
		return;
	}
	if(!strcasecmp(parv[1],"add"))
	{
		struct track *track = NULL;
		struct userinfo *user=NULL;
		if(parc < 2)
		{
			uwntc(nick->numeric, "Syntaxe: TRACK ADD <username> [expiration]");
			return;
		}
		if((track = istrack(parv[2])))
		{
			uwntc(nick->numeric, "\2%s\2 est dj track par %s (depuis %s)", track->nick, track->reqn, duration(time(NULL)-track->expire));
			return;
		}
		if(!strcasecmp(parv[1],nick->user->nick))
		{
			uwntc(nick->numeric, "Pourquoi se traquer soi-mme!?");
			return;
		}
		if(!(user = getuserinfo(parv[2])))
		{
			uwntc(nick->numeric, NOSUCHUSER, parv[2]);
			return;
		}
		if(user->level > 1 && nick->user->level < 4)
		{
			uwntc(nick->numeric, "Veuillez ne pas tracker un Admin.");
			return;
		}
		add_track(user->nick, nick->user->nick, nick->numeric, (parc > 2 && is_num(parv[3])) ? atol(parv[3]) : 0);
		uwntc(nick->numeric, "\2%s\2 a t ajout a vos tracks. (Expire dans %s)", user->nick, (parc > 2 && is_num(parv[3])) ? duration(time(NULL) - atol(parv[3])) : "Jamais");
		return;
	}
	if(!strcasecmp(parv[1],"del"))
	{
		struct track *track = NULL;
		if(parc < 2)
		{
			uwntc(nick->numeric, "Syntaxe: TRACK DEL <username>");
			return;
		}
		if(!(track = istrack(parv[2])))
		{
			uwntc(nick->numeric, "\2%s\2 n'est pas track.", parv[2]);
			return;
		}
		if(strcasecmp(track->reqn,nick->user->nick))
		{
			uwntc(nick->numeric, "\2%s\2 est actuellement track par %s.", track->nick, track->reqn);
			return;
		}
		del_track(track->nick);
		uwntc(nick->numeric, "%s a t supprim de vos tracks.", parv[2]);
		return;
	}
	uwntc(nick->numeric, "Commande invalide");
	return;
}
